/* Here for the 'sleep' command which should be replaced with something else. */
#include <stdlib.h>




#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <string.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "parsecli.h"
#include "define.h"
#include "netutil.h"
#include "../server_basic_modules/common/recvenum.h"
#include "server_form.h"
#include "../client_basic_modules/common/module.h"
#include "save_layout.h"
#include "load_layout.h"

//#include "./art/p_card.xpm"

void
send_pcards_selected(GtkWidget *widget, gpointer user_data) {
//	GdkColormap *colormap;
//	GdkPixmap *pixmap;
//	GdkBitmap *bitmap;
	struct mother_hold *mother;
	gchar *card_id;
	int ctr;
	gchar tosend[512];
	int count;
				 
//	g_print("sending pcards selected\n");

	mother = (struct mother_hold*)user_data;

	/* first, does this user want to issue a shutdown? */
	if(gtk_toggle_button_get_active(
			GTK_TOGGLE_BUTTON(mother->main_form.shutdown_toggle))) {

		/* pop the button back up */
		gtk_toggle_button_set_active(
				GTK_TOGGLE_BUTTON(mother->main_form.shutdown_toggle),
				FALSE);

		g_print("REQUESTING SHUTDOWN\n");
		tosend[0] = C_I_WANT_TO_SHUTDOWN;
		writen(mother->socket, tosend, 1);
	}

	/* hide the program card selection form */
	gtk_widget_hide(mother->main_form.pcard_select_form);

	tosend[0] = C_P_CARD_SELECTION;

	count = 0;
	for(ctr = 0; ctr < 5; ctr ++) {
//		if(this_card_is_not_locked) {
			gtk_label_get(GTK_LABEL(
					mother->main_form.label_select[ctr]),
					&card_id);
//			g_print("card one id is: %s\n", card_id);
			tosend[2+ctr] = atoi(card_id);

			count++;
//		}
	}

	tosend[1] = count;
	writen(mother->socket, tosend, 2+tosend[1]);

	/**
	 * clear the selected cards to blanks
	 */
/*
	colormap = gtk_widget_get_colormap(mother->main_form.pcard_select_form);
	pixmap = gdk_pixmap_colormap_create_from_xpm_d(
			NULL, colormap, &bitmap,
			NULL, p_card_xpm);

	for(ctr = 0; ctr < 5; ctr ++) {
		gtk_pixmap_set(GTK_PIXMAP(
				mother->main_form.select[ctr]),
				pixmap, bitmap);
		gtk_label_set_text(GTK_LABEL(
				mother->main_form.label_select[ctr]),
				"");
	}
*/
//	gdk_pixmap_unref(pixmap);
//	gdk_bitmap_unref(bitmap);
}

void
check_pcards_selected(GtkWidget *widget, gpointer user_data) {
	struct mother_hold *mother;
	int total;
	int first_total;
	int second_total;
	int first_location;
	int second_location;
	int ctr;
	gchar *hold_label1;
	gchar *hold_label2;
	gchar tmp1_label[512];
	gchar tmp2_label[512];
	GdkPixmap *tmp1_pixmap;
	GdkPixmap *tmp2_pixmap;
	GdkBitmap *tmp1_bitmap;
	GdkBitmap *tmp2_bitmap;
				 
	mother = (struct mother_hold*)user_data;

	first_total = second_total = 0;
	first_location = -1;
	for(ctr = 0; ctr < 5; ctr ++) {
		if(gtk_toggle_button_get_active(
				GTK_TOGGLE_BUTTON(mother->main_form.toggle_select[ctr]))) {
			first_total++;
			if(first_location == -1) {
				first_location = ctr;
			}
			else {
				second_location = ctr;
				break;
			}
		}
	}
	for(ctr = 0; ctr < 9; ctr ++) {
		if(gtk_toggle_button_get_active(
				GTK_TOGGLE_BUTTON(mother->main_form.toggle_pickme[ctr]))) {
			second_total++;
			if(first_location == -1) {
				first_location = ctr;
			}
			else {
				second_location = ctr;
				break;
			}
		}
	}

	total = first_total+second_total;
	if(total == 0) {
		return;
	}
	else if(total == 1) {
		return;
	}
	else if(total == 2) {
		if(first_total != 1) {
			/* untoggle all the buttons */
			for(ctr = 0; ctr < 5; ctr ++) {
				gtk_toggle_button_set_active(
						GTK_TOGGLE_BUTTON(mother->main_form.toggle_select[ctr]),
						FALSE);
			}
			for(ctr = 0; ctr < 9; ctr ++) {
				gtk_toggle_button_set_active(
						GTK_TOGGLE_BUTTON(mother->main_form.toggle_pickme[ctr]),
						FALSE);
			}
			return;
		}

		if(second_total != 1) {
			/* untoggle all the buttons */
			for(ctr = 0; ctr < 5; ctr ++) {
				gtk_toggle_button_set_active(
						GTK_TOGGLE_BUTTON(mother->main_form.toggle_select[ctr]),
						FALSE);
			}
			for(ctr = 0; ctr < 9; ctr ++) {
				gtk_toggle_button_set_active(
						GTK_TOGGLE_BUTTON(mother->main_form.toggle_pickme[ctr]),
						FALSE);
			}
			return;
		}

		/* swap the two cards */
//		g_print("swapping the cards\n");

		/* swap labels */
		gtk_label_get(GTK_LABEL(
				mother->main_form.label_select[first_location]),
				&hold_label1);
		gtk_label_get(GTK_LABEL(
				mother->main_form.label_pickme[second_location]),
				&hold_label2);

		strcpy(tmp1_label, hold_label1);
		strcpy(tmp2_label, hold_label2);

		gtk_label_set_text(GTK_LABEL(
				mother->main_form.label_select[first_location]),
				tmp2_label);
		gtk_label_set_text(GTK_LABEL(
				mother->main_form.label_pickme[second_location]),
				tmp1_label);

		gtk_pixmap_get(GTK_PIXMAP(
				mother->main_form.select[first_location]),
				&tmp1_pixmap, &tmp1_bitmap);
		gtk_pixmap_get(GTK_PIXMAP(
				mother->main_form.pickme[second_location]),
				&tmp2_pixmap, &tmp2_bitmap);

		gtk_pixmap_set(GTK_PIXMAP(
				mother->main_form.select[first_location]),
				tmp2_pixmap, tmp2_bitmap);
		gtk_pixmap_set(GTK_PIXMAP(
				mother->main_form.pickme[second_location]),
				tmp1_pixmap, tmp1_bitmap);

/* should these be used? this a memory leak? */
//		gdk_pixmap_unref(tmp1_pixmap);
//		gdk_pixmap_unref(tmp2_pixmap);
//		gdk_bitmap_unref(tmp1_bitmap);
//		gdk_bitmap_unref(tmp2_bitmap);

		/* untoggle all the buttons */
		for(ctr = 0; ctr < 5; ctr ++) {
			gtk_toggle_button_set_active(
					GTK_TOGGLE_BUTTON(mother->main_form.toggle_select[ctr]),
					FALSE);
		}
		for(ctr = 0; ctr < 9; ctr ++) {
			gtk_toggle_button_set_active(
					GTK_TOGGLE_BUTTON(mother->main_form.toggle_pickme[ctr]),
					FALSE);
		}
	}
}

void
file_select_design_load_ok_clicked(GtkWidget *widget, gpointer user_data) {
	struct mother_hold *mother;
	char *ptr;
				 
	mother = (struct mother_hold*)user_data;
	gtk_widget_hide(mother->server_form.tab2.file_selection_design_load);

	ptr = gtk_file_selection_get_filename(
			GTK_FILE_SELECTION(mother->server_form.tab2.file_selection_design_load));
	if(load_layout(mother, ptr)) {
		gtk_file_selection_set_filename(
				GTK_FILE_SELECTION(mother->server_form.tab2.file_selection_design_save),
				ptr);
	}
}

void
file_select_design_load_cancel_clicked(GtkWidget *widget, gpointer user_data) {
	struct mother_hold *mother;
				 
	mother = (struct mother_hold*)user_data;
	gtk_widget_hide(mother->server_form.tab2.file_selection_design_load);
}

void
file_select_design_save_ok_clicked(GtkWidget *widget, gpointer user_data) {
	struct mother_hold *mother;
	char *ptr;
				 
	mother = (struct mother_hold*)user_data;
	gtk_widget_hide(mother->server_form.tab2.file_selection_design_save);

	ptr = gtk_file_selection_get_filename(
			GTK_FILE_SELECTION(mother->server_form.tab2.file_selection_design_save));
	save_layout(mother, ptr);
}

void
file_select_design_save_cancel_clicked(GtkWidget *widget, gpointer user_data) {
	struct mother_hold *mother;
				 
	mother = (struct mother_hold*)user_data;
	gtk_widget_hide(mother->server_form.tab2.file_selection_design_save);
}

int get_server_ref_num_from_client(struct mother_hold *mother, int needle) {
	struct node_user_type *server_slider;
	struct node_module_type *module_slider;
	int module_count;

	/* find the client module and get its name & version */
	module_count = 0;
	module_slider = mother->module_head;
	while(module_slider) {
		if(module_count == needle) {
			break;
		}

		module_count++;
		module_slider = module_slider->next_module;
	}

	server_slider = mother->server_head;
	while(server_slider) {
//		g_print("comparing '%s' and '%s\n",
//				server_slider->nick,
//				module_slider->name);
		if(!strcmp(server_slider->nick+1, module_slider->name+1)) {
			break;
		}
//		g_print("module '%s' (%d)\n", server_slider->nick, server_slider->id);

		server_slider = server_slider->next_user;
	}
	if(!server_slider) {
		return -1;
	}

	return server_slider->id;
}

void
on_stop_game_activate                 (GtkWidget       *button,
                                        gpointer         user_data) {
	struct mother_hold *mother;
	char tosend[512];

	mother = (struct mother_hold*)user_data;

	tosend[0] = C_ADMIN_STOP_GAME;
	writen(mother->socket, tosend, 1);
}

/* Player has clicked the 'start game' button */
void
on_start_game_activate                 (GtkWidget       *button,
                                        gpointer         user_data) {
	struct node_layout_type *layout_slider;
	struct mother_hold *mother;
	char tosend[512];
	int server_module_ref_num;
	int time_to_pause;
				 
	mother = (struct mother_hold*)user_data;

	g_print("******************************************************************\n");
	g_print("* The delay being used in this function may not be enough for    *\n");
	g_print("* faster systems.  If the user buffer is being cleared by the    *\n");
	g_print("* server that is the problem... delays must be increased.        *\n");
	g_print("* Need a better system of delay which will work for all systems. *\n");
	g_print("******************************************************************\n");

	if(mother->socket == 0) {
		g_print("Not connected to server, can't start game.\n");
		return;
	}

	/* send the size of the world */
	tosend[0] = C_ADMIN_SET_WORLD_WIDTH;
	tosend[1] = gtk_spin_button_get_value_as_int(
			GTK_SPIN_BUTTON(mother->server_form.tab2.spin_world_button_x));
	writen(mother->socket, tosend, 2);

	tosend[0] = C_ADMIN_SET_WORLD_HEIGHT;
	tosend[1] = gtk_spin_button_get_value_as_int(
			GTK_SPIN_BUTTON(mother->server_form.tab2.spin_world_button_y));
	writen(mother->socket, tosend, 2);
/*
	tosend[0] = C_ADMIN_SET_NUMBER_OF_ELEMENTS;
	tosend[1] = 3;
	tosend[2] = '1';
	tosend[3] = '2';
	tosend[4] = '0';
	writen(mother->socket, tosend, 5);
*/
	/* send the initial archive location for all robots */
	tosend[0] = C_ADMIN_SET_ARCHIVE_LOCATION;
	tosend[1] = gtk_spin_button_get_value_as_int(
			GTK_SPIN_BUTTON(mother->server_form.tab2.spin_spawn_button_x));
	tosend[2] = gtk_spin_button_get_value_as_int(
			GTK_SPIN_BUTTON(mother->server_form.tab2.spin_spawn_button_y));
	writen(mother->socket, tosend, 3);

	/* send the layout description */
	time_to_pause = 0;
	layout_slider = mother->design_head;
	while(layout_slider) {
		server_module_ref_num =
				get_server_ref_num_from_client(mother, layout_slider->id);

		if(server_module_ref_num == -1) {
			g_print("Error: The server does not have a module loaded that\n");
			g_print("Error: we are trying to send it. Such as trying to\n");
			g_print("Error: send a tred when the server hasn't loaded the\n");
			g_print("Error: tred module.\n");
			g_print("Error:\n");
			g_print("Error: Giving up sending anymore elements to server.\n");
			g_print("Error: Aborting sending the start command.\n");
			return;
		}

		/* send this element to the server */
		tosend[0] = C_ADMIN_ADD_ELEMENT;
		tosend[1] = server_module_ref_num;
		tosend[2] = layout_slider->x / 250;
		tosend[3] = layout_slider->x % 250;
		tosend[4] = layout_slider->y / 250;
		tosend[5] = layout_slider->y % 250;
		tosend[6] = layout_slider->instance;
		writen(mother->socket, tosend, 7);

		for(time_to_pause = 0; time_to_pause != 60000; time_to_pause++);
		for(time_to_pause = 0; time_to_pause != 60000; time_to_pause++);
		for(time_to_pause = 0; time_to_pause != 60000; time_to_pause++);

		/* We don't want to overflow our buffer on the server so pause every */
		/* few elements. */
		if(++time_to_pause == 50) {
//			for(time_to_pause = 0; time_to_pause != 50000; time_to_pause++);
//			system("sleep 1");
			time_to_pause = 0;
		}

		layout_slider = layout_slider->next_element;
	}

	/* send the command to start the game */
	tosend[0] = C_ADMIN_START_GAME;
	writen(mother->socket, tosend, 1);
}

void
passwd_button_clicked                  (GtkWidget       *passwd_button,
                                        gpointer         user_data)
{
	struct mother_hold *mother;
	char tosend[512];
	char *buff;
				 
	mother = (struct mother_hold*)user_data;

//	gtk_widget_hide(status_form);
//	g_print("Passwd Button Clicked: %s\n", mother->usernick);

	buff = gtk_entry_get_text(GTK_ENTRY(mother->server_form.tab1.passwd_entry));
	tosend[0] = C_ADMIN_GAIN_ACCESS;
	tosend[1] = strlen(buff) + 1;
	strcpy(tosend+2, buff);
	writen(mother->socket, tosend, strlen(buff)+3);
}

void
hide_news_form                         (GtkWidget       *news_form,
                                        gpointer         user_data)
{
	gtk_widget_hide(news_form);
}

void
hide_status_form                       (GtkWidget       *status_form,
                                        gpointer         user_data)
{
	gtk_widget_hide(status_form);
}

void
hide_server_form                       (GtkWidget       *server_form,
                                        gpointer         user_data)
{
	struct mother_hold *mother;
				 
	mother = (struct mother_hold*)user_data;

	gtk_widget_hide(server_form);
//	g_print("Hiding: %s\n", mother->usernick);
}

void
on_connect1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	struct mother_hold *mother;
				 
	mother = (struct mother_hold*)user_data;

	gtk_widget_show(mother->main_form.login_form);
}


void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_main_quit();
}


void
on_configure1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	struct mother_hold *mother;
				 
	mother = (struct mother_hold*)user_data;

	gtk_widget_show(mother->server_form.main_window);
}


void
on_view1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_view_status1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	struct mother_hold *mother;
				 
	mother = (struct mother_hold*)user_data;

	gtk_widget_show(mother->status_form);
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	struct mother_hold *mother;
	struct node_layout_type *layout_slider;
	struct node_layout_type *killme_slider;
	char buff[512];
				 
	mother = (struct mother_hold*)user_data;

	/* Clear out the design link list. */
	layout_slider = mother->design_head;
	while(layout_slider) {
		killme_slider = layout_slider;
		layout_slider = layout_slider->next_element;

		/* remove this node */
		g_free(killme_slider);
	}
	mother->design_head = NULL;

	/* Update the design display. */
	update_server_form_display(mother);

	/* set the filename to untitled */
	gtk_file_selection_set_filename(
			GTK_FILE_SELECTION(mother->server_form.tab2.file_selection_design_save),
			"untitled.brd");

	/* set the filename in the title appropriately */
	strcpy(buff, "Server Configuration: 'untitled.brd'");
	gtk_window_set_title(
			GTK_WINDOW (mother->server_form.main_window), buff);
}


void
on_load1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	struct mother_hold *mother;
//	char tosend[512];
				 
	mother = (struct mother_hold*)user_data;

	/* Load the design view board. */
	gtk_widget_show(mother->server_form.tab2.file_selection_design_load);
}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	struct mother_hold *mother;
	char *ptr;
	char buff[512];
				 
	mother = (struct mother_hold*)user_data;

	/* form a file name which is the default to save the board as if */
	/* they haven't specified a name yet to check and pop up the save */
	/* as to make the specify a name. */
	ptr = getenv("PWD");
	strcpy(buff, ptr);
	strcat(buff, "/untitled.brd");

	/* get the current file name in the file selection dialog */
	ptr = gtk_file_selection_get_filename(
			GTK_FILE_SELECTION(mother->server_form.tab2.file_selection_design_save));

	/* either save, or pop up the save as dialog */
	if(!strcmp(ptr, buff)) {
		gtk_widget_show(mother->server_form.tab2.file_selection_design_save);
	}
	else {
		save_layout(mother, ptr);
	}
}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	struct mother_hold *mother;
				 
	mother = (struct mother_hold*)user_data;

	/* Save the design view board. */
	gtk_widget_show(mother->server_form.tab2.file_selection_design_save);
}


void
on_close1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	struct mother_hold *mother;
	char buff[512];
				 
	mother = (struct mother_hold*)user_data;

	/* set the filename to untitled */
	gtk_file_selection_set_filename(
			GTK_FILE_SELECTION(mother->server_form.tab2.file_selection_design_save),
			"untitled.brd");

	/* set the filename in the title appropriately */
	strcpy(buff, "Server Configuration");
	gtk_window_set_title(
			GTK_WINDOW (mother->server_form.main_window), buff);
}


void
on_exit2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_main_form_data_entry_activate                 (GtkWidget  *data_entry,
				                        gpointer   user_data)
{
	struct mother_hold *mother;
	gchar *string;
				 
	mother = (struct mother_hold*)user_data;
					 
	string = gtk_entry_get_text(GTK_ENTRY(data_entry));
						 
	parse_client(mother, string);
							 
	/* Now lets clear out the entry line so we can
	 * do other stuff */
	gtk_entry_set_text(GTK_ENTRY(mother->main_form.data_entry), "");
}
