#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <ctype.h>
#include "netutil.h"
#include "../server_basic_modules/common/recvenum.h"

void identify(register int, char*);

int cli_connect(char *host, char *port, char *nick)
{
	int		sockfd;
	struct	sockaddr_in	serv_addr;
	struct	hostent *ph;
	long	address;

	memset((char *) &serv_addr, '\0', sizeof(serv_addr));

	if(isdigit((size_t)*host)) {
		if((address = inet_addr(host)) == -1) {
			/* Failed */
			return 0;
		}
		serv_addr.sin_family		= AF_INET;
		serv_addr.sin_addr.s_addr	= address;
	}
	else if((ph = gethostbyname(host)) == NULL) {
		/* Failed */
		return 0;
	}
	else {
		serv_addr.sin_family		= ph->h_addrtype;
		memcpy((char*) &serv_addr.sin_addr, ph->h_addr, ph->h_length);
	}

	serv_addr.sin_port		= htons(atol(port));

	/* ignore broken pipes ??? it was in freeciv, we'll keep it */
/*	signal (SIGPIPE, SIG_IGN);
*/
	/*
	 * Open a TCP socket (an internet stream socket).
	 */
	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
		perror("client: can't open stream socket");

	/*
	 * Connect to the server
	 */
	if (connect (sockfd, (struct sockaddr *) &serv_addr,
			sizeof(serv_addr)) < 0) {
		perror("client: can't connect to the server");
		return 0;
	}

	identify(sockfd, nick);

	return sockfd;
}

void identify (sockfd, nick)
register int sockfd;
char *nick;
{
	char buff[256];

	/* Attempt to change to the requested nick (it may fail) */
	buff[0] = C_CHANGE_NICK;
	buff[1] = strlen(nick)+1;
	strcpy(buff+2, nick);
	writen(sockfd, buff, buff[1]+2);
} 
