#ifndef DEFINE
#define DEFINE

#define RRCLIENT_VER "Robot Race v0.36"

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#define USE_AI FALSE

#include <gtk/gtk.h>
#include "server_form_def.h"
#include "robot.h"

/* Used to describe a board layout */
typedef struct node_layout_type {
  int   id; /* client module number */
  long  x;
  long  y;
  long  location;
  int   instance;
  int	display_depth;	/* this could be looked up but is here for convenience */
  struct node_layout_type *next_element;
}   node_layout_type, *node_layout_ptr;

typedef struct node_user_type {
  int	id;
  char *nick;
  struct node_user_type *next_user;
}	node_user_type, *node_user_ptr;

struct main_form_hold {
	GtkWidget *main_window;
	GtkWidget *chat_display;
	GtkWidget *data_entry;
	GtkWidget *user_list_clist;

	GtkWidget *game_display_gtkpixmap;
	GdkPixmap *game_display_pixmap;
	GdkBitmap *game_display_bitmap;
	GdkPixmap *game_display_pixmap_backup;
	GdkBitmap *game_display_bitmap_backup;
	int width;
	int height;

	GtkWidget *pcard_select_form;
	GtkWidget *locked[5];
	GtkWidget *select[5];
	GtkWidget *label_select[5];
	GtkWidget *pickme[9];
	GtkWidget *label_pickme[9];
	GtkWidget *toggle_select[5];
	GtkWidget *toggle_pickme[9];
	GtkWidget *shutdown_toggle;

	GdkPixmap *program_cards_pixmap[7];
	GdkBitmap *program_cards_bitmap[7];

	GtkWidget *spawn_select_form;
	GtkWidget *toggle_spawn[4];
	GtkWidget *spawn_gtkpixmap[4];

	GtkWidget *login_form;
	GtkWidget *login_nick;
	GtkWidget *login_host;
	GtkWidget *login_port;

	GtkWidget *news_form;
	GtkWidget *text_listing;
};

struct mother_hold {
	node_user_ptr user_head;	/* Beginning of user linked listed */
	node_layout_ptr game_head;	/* Description of game board layout */
	node_layout_ptr design_head;	/* Description of design board layout */
	node_robot_ptr	robot_head;
	int socket;
	int whoami;
	char *usernick;
	char *hostname;
	char *hostport;

	/* Link list of client modules */
	struct node_module_type *module_head;
	struct node_user_type *server_head;	/* this is the link list of server modules */
	int number_of_modules_loaded;

	/* GUI global variables */
	GtkWidget *status_form;
	struct main_form_hold main_form;
	struct server_form_hold server_form;

	/* temporary storage for things game related */
	long initial_archive_location_x;
	long initial_archive_location_y;
	long number_of_elements;
};

#endif /* DEFINE */
