

#include "parseser.h"
#include "clinet.h"
#include "define.h"

void on_login_connect(GtkWidget *widget, gpointer user_data) {
	struct mother_hold *mother;
	gchar *nick, *host, *port;
//	gchar tosend[512];

	mother = (struct mother_hold*)user_data;                                               

//	g_print("trying to connect to server\n");

	/* hide the login form */
	gtk_widget_hide(mother->main_form.login_form);

	/* use the information provided to try and connect to the server */
	nick = gtk_entry_get_text(
				GTK_ENTRY(mother->main_form.login_nick));
	host = gtk_entry_get_text(
				GTK_ENTRY(mother->main_form.login_host));
	port = gtk_entry_get_text(
				GTK_ENTRY(mother->main_form.login_port));

	g_free(mother->usernick);
	g_free(mother->hostname);
	g_free(mother->hostport);

	mother->usernick = g_strdup(nick);
	mother->hostname = g_strdup(host);
	mother->hostport = g_strdup(port);

	mother->socket = cli_connect(
			mother->hostname,
			mother->hostport,
			mother->usernick);

	/* Did the connect succeed? */
	if(mother->socket) {
		gtk_text_insert(
				GTK_TEXT(mother->main_form.chat_display),
				NULL, NULL, NULL,
			    "\n*** Connection Succeeded...",
				strlen("\n*** Connection Succeeded..."));

		/* Add the socket to be watched by GTK */
		gdk_input_add(mother->socket, GDK_INPUT_READ, parse_server, mother);
	}
	else {
		gtk_text_insert(
				GTK_TEXT(mother->main_form.chat_display),
				NULL, NULL, NULL,
				"\n*** Connection to server failed...",
				strlen("\n*** Connection to server failed..."));
	}
}

GtkWidget*
create_login_form (struct mother_hold *mother)
{
  GtkWidget *login_window;
  GtkWidget *vbox4;
  GtkWidget *hbox5;
  GtkWidget *label1;
  GtkWidget *hbox6;
  GtkWidget *label2;
  GtkWidget *hbox7;
  GtkWidget *label3;
  GtkWidget *button1;

  login_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (login_window), "login_window", login_window);
  gtk_window_set_title (GTK_WINDOW (login_window), "Data Entry");
  gtk_window_set_policy (GTK_WINDOW (login_window), TRUE, TRUE, FALSE);
  gtk_widget_set_usize (login_window, 250, 90);
  gtk_widget_hide(login_window);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (login_window), "vbox4", vbox4);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (login_window), vbox4);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (login_window), "hbox5", hbox5);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox5, FALSE, TRUE, 0);

  label1 = gtk_label_new ("Player Name:");
  gtk_object_set_data (GTK_OBJECT (login_window), "label1", label1);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox5), label1, FALSE, FALSE, 5);

  mother->main_form.login_nick = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (login_window),
		"mother->main_form.login_nick", mother->main_form.login_nick);
  gtk_widget_show (mother->main_form.login_nick);
  gtk_box_pack_start (GTK_BOX (hbox5), mother->main_form.login_nick, TRUE, TRUE, 0);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (login_window), "hbox6", hbox6);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox6, FALSE, TRUE, 0);

  label2 = gtk_label_new ("Server IP:");
  gtk_object_set_data (GTK_OBJECT (login_window), "label2", label2);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox6), label2, FALSE, FALSE, 15);

  mother->main_form.login_host = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (login_window),
		"mother->main_form.login_host", mother->main_form.login_host);
  gtk_widget_show (mother->main_form.login_host);
  gtk_box_pack_start (GTK_BOX (hbox6), mother->main_form.login_host, TRUE, TRUE, 0);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (login_window), "hbox7", hbox7);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox7, FALSE, TRUE, 0);

  label3 = gtk_label_new ("Port #");
  gtk_object_set_data (GTK_OBJECT (login_window), "label3", label3);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox7), label3, FALSE, FALSE, 26);

  mother->main_form.login_port = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (login_window),
		"mother->main_form.login_port", mother->main_form.login_port);
  gtk_widget_show (mother->main_form.login_port);
  gtk_box_pack_start (GTK_BOX (hbox7), mother->main_form.login_port, TRUE, TRUE, 0);

  button1 = gtk_button_new_with_label ("Connect!");
  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (on_login_connect),
                      (gpointer) mother);
  gtk_object_set_data (GTK_OBJECT (login_window), "button1", button1);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (vbox4), button1, TRUE, TRUE, 0);

  return login_window;
}
