#include <gtk/gtk.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "define.h"
#include "../client_basic_modules/common/module.h"
#include "callbacks.h"
#include "edit_layout.h"
#include "update.h"

int load_layout(mother, filename)
struct mother_hold *mother;
gchar *filename;
{
	long max_row, max_col;
	struct node_module_type *module_slider;
	struct node_layout_type *layout_slider, *killme_slider;
	FILE *infile;
	char buff[512], *tmp, *ptr, *begining;
	char module_name[512];
	char module_vers[512];
	int location_of_image;
	int module_id;
	long row, col;
	int instance;
	/* This is hardcoding, should use a node list instead. */
	char module_list_name[150][512];
	char module_list_vers[150][512];
	int module_list_ref[150];
	int number_of_reference_modules;
	int store_edit_toggle;
	int store_display_toggle;
	GdkRectangle update_rect;
	long number_of_elements_total;
	long number_of_elements_so_far;

	store_edit_toggle = mother->server_form.tab2.current_edit_toggle;
	store_display_toggle = mother->server_form.tab2.current_display_toggle;

	/* Clear out the design link list. */
	layout_slider = mother->design_head;
	while(layout_slider) {
		killme_slider = layout_slider;
		layout_slider = layout_slider->next_element;

		/* remove this node */
		g_free(killme_slider);
	}
	mother->design_head = NULL;

	/* Load the design view board. */
//	g_print("LOADING BOARD:\n");
	g_print("Module version conflict warnings have been removed for now.\n");

	infile = fopen(filename, "r");
	if(infile == NULL) {
		g_print("Error: File '%s' not found to load.  Ignoring request.\n", filename);
		return FALSE;
	}

	/* load the world size */
	fgets(buff, 20, infile);
	ptr = strstr(buff, " ");
	tmp = ptr + 1;
	ptr = 0;
	max_col = atol(buff);
	max_row = atol(tmp);
//	g_print("col = %ld, row = %ld\n", max_col, max_row);

	/* Set the spin buttons appropriately. */
	gtk_spin_button_set_value(
			GTK_SPIN_BUTTON(mother->server_form.tab2.spin_world_button_x),
			max_col);
	gtk_spin_button_set_value(
			GTK_SPIN_BUTTON(mother->server_form.tab2.spin_world_button_y),
			max_row);

	/* Call the File->New callback to initiate the new board layout & size */
	on_new1_activate(NULL, (gpointer)mother);

	strcpy(buff, "Server Configuration: '");
	strcat(buff, filename);
	strcat(buff, "'");
	gtk_window_set_title(
			GTK_WINDOW (mother->server_form.main_window), buff);

	/* display the progress bar window to show the loading speed... */
	gtk_window_set_title (GTK_WINDOW(
  			mother->server_form.tab2.design_progress_bar_window),
			"Loading up design layout...");
	gtk_widget_show(mother->server_form.tab2.design_progress_bar_window);

	fgets(buff, 80, infile);
	number_of_reference_modules = 0;
	while(strcmp(buff, "listing start:\n")) {
		begining = buff;
		ptr = strstr(begining, " ");
		tmp = ptr + 1;
		ptr[0] = 0;
		/* The above 4 lines got rid of 'module: ' */

		begining = tmp;
		ptr = strstr(begining, ",");
		tmp = ptr + 2;
		ptr[0] = 0;
		strcpy(module_name, begining);

		begining = tmp;
		ptr = strstr(begining, ",");
		tmp = ptr + 2;
		ptr[0] = 0;
		strcpy(module_vers, begining);

		begining = tmp;
		module_id = atoi(tmp);

//		g_print("Module identified: '%s', version: '%s', ref# %d\n",
//				module_name, module_vers, module_id);

		strcpy(module_list_name[number_of_reference_modules], module_name);
		strcpy(module_list_vers[number_of_reference_modules], module_vers);
		module_list_ref[number_of_reference_modules] = module_id;
		number_of_reference_modules++;

		fgets(buff, 80, infile);
	}

	fgets(buff, 80, infile);
	number_of_elements_total = atol(buff);

	/* add each element one by one */
	number_of_elements_so_far = 0;
	fgets(buff, 80, infile);
//	while(strcmp(buff, "listing finished.\n")) {
	while(!feof(infile)) {
//		g_print("manipulating: %s", buff);

		/* find first value */
		begining = buff;
		ptr = strstr(begining, " ");
		tmp = ptr + 1;
		ptr[0] = 0;
		/* use first value */
		module_id = atoi(begining);

		/* find second value */
		begining = tmp;
		ptr = strstr(begining, " ");
		tmp = ptr + 1;
		ptr[0] = 0;
		/* use second value */
		col = atol(begining);

		/* find third value */
		begining = tmp;
		ptr = strstr(begining, " ");
		tmp = ptr + 1;
		ptr[0] = 0;
		/* use third value */
		row = atol(begining);

		/* find fouth value (already found) */
		begining = tmp;
		instance = atoi(begining);

		/**
		 * Add this element to our storeage & to the gui
		 */

		/* Set the destination for this element */
		mother->server_form.tab2.current_display_toggle =
				row * max_col + col;

		/* Find which element to draw */
		module_slider = mother->module_head;
		location_of_image = 0;
		while(module_slider) {
			if(!strcmp(module_slider->name+1, module_list_name[module_id]+1)) {
				if(!strcmp(module_slider->info->version, module_list_vers[module_id])) {
					/* ok, name and version are the same, load it */
					location_of_image += instance;
					break;
				}
				else {
/*
					g_print("Warning: module versions don't match. '%s:%s', '%s:%s'\n",
						module_slider->name,
						module_slider->info->version,
					   	module_list_name[module_id],
					   	module_list_vers[module_id]);
					g_print("Warning: Trying to load anyways.\n");
*/

					/* ok, names are the same, try and load it */
					location_of_image += instance;
					break;
				}
			}
			location_of_image += module_slider->info->number_of_small_images;
			module_slider = module_slider->next_module;
		}
		if(!module_slider) {
			/* hide the progress bar window now that the loading has failed... */
			gtk_widget_hide(mother->server_form.tab2.design_progress_bar_window);

			g_print("Error: No module is loaded which matches the layout description.\n");
			g_print("Error: Load failed, giving up.\n");
			return FALSE;
		}

//		g_print("we are drawing a '%s' using image #%d\n",
//				module_list_name[module_id], location_of_image);

//		g_print("ignoring which object to draw, always drawing treds.\n");
		mother->server_form.tab2.current_edit_toggle = location_of_image;
		add_to_layout(mother);
	    update_design_layout(mother, mother->server_form.tab2.current_display_toggle);

		number_of_elements_so_far++;

		/* Update our progress bar so the user knows how much time is left. */
		gtk_progress_bar_update(
				GTK_PROGRESS_BAR(mother->server_form.tab2.design_progress_bar),
				number_of_elements_so_far / (float)number_of_elements_total);
		/* update the spot which was drawn to */
	    update_rect.x = 0;
		update_rect.y = 0;
		update_rect.width = 250;
		update_rect.height = 100;
		gtk_widget_draw(
				mother->server_form.tab2.design_progress_bar,
				&update_rect);

		fgets(buff, 80, infile);
	}

	/* hide the progress bar window now that the loading is finished... */
	gtk_widget_hide(mother->server_form.tab2.design_progress_bar_window);

    mother->server_form.tab2.current_edit_toggle = store_edit_toggle;
    mother->server_form.tab2.current_display_toggle = store_display_toggle;

	fclose(infile);

	return TRUE;
}
