#include <string.h>
#include <stdlib.h>
#include <dlfcn.h>
#include "define.h"
#include "../client_basic_modules/common/module.h"

/* Find module then unload it & remove its node from the linked list */
int unload_module(struct mother_hold *mother, char *module_name) {
	node_module_ptr fix_module_ptr;
	node_module_ptr module_slider;


	/* Find the module node in the linked list */
	module_slider = mother->module_head;
	if(module_slider == NULL) {
		g_print(">! exit 1\n");
		return FALSE;
	}
	g_print(">! comparing '%s' & '%s'\n", module_slider->name, module_name);
	while(strcmp(module_slider->name, module_name)) {
		module_slider = module_slider->next_module;
		if(module_slider == NULL) {
			g_print(">! exit 2\n");
			return 1;
		}

		g_print(">! comparing '%s' & '%s'\n", module_slider->name, module_name);
	}

	/* Now fix the linked list so we can remove this node */
	fix_module_ptr = mother->module_head;
	if(fix_module_ptr == module_slider) {
		mother->module_head = NULL;
	}
	else {
		while(fix_module_ptr->next_module != module_slider) {
			if(fix_module_ptr->next_module == NULL) {
				g_print(">! stdin admin tried to unload module not loaded.\n");
				g_print(">! exit 3\n");
				return 1;
			}
			fix_module_ptr = fix_module_ptr->next_module;
		}
		fix_module_ptr->next_module = module_slider->next_module;
	} 

	/* Subtract another module to the number of modules connected */
	mother->number_of_modules_loaded --;

    dlclose(module_slider->handle);
	g_free(module_slider);

	return TRUE;
}

int load_module(struct mother_hold *mother, char *module_name) {
	struct initial_info_hold*(*get_info)(void);
	void (*initialize)(struct mother_hold*);
	void *tmp_handle;
	char buff[512];
	node_module_ptr module_slider;
	node_module_ptr new_module_ptr;

	g_print(">! loading module '%s', result: ", module_name);

	/* Attempt to open the module */
	strcpy(buff, module_name);
	strcat(buff, ".so");
	g_print("'%s': ", buff);
	tmp_handle = dlopen(buff, RTLD_LAZY);
	if(!tmp_handle) {
/*		fputs (dlerror(), stderr);
*/		g_print("failed to load.\n");

		return FALSE;
	}

	strcpy(buff, "initialize");
	initialize = dlsym(tmp_handle, buff);
	initialize(mother);

	strcpy(buff, "query_initial_info");
	get_info = dlsym(tmp_handle, buff);

	/* Allocate a new module node for this new module */
	new_module_ptr = (node_module_ptr) calloc (1, sizeof(node_module_type));

	/* Fill in the new information about the module */
	new_module_ptr->name = g_strdup(module_name);
	new_module_ptr->handle = tmp_handle;
	new_module_ptr->info = get_info();
/* Move to the end of the node list & attach */
	module_slider = mother->module_head;
	if(module_slider == NULL) {
		mother->module_head = new_module_ptr;
	}
	else if(module_slider->next_module == NULL) {
		module_slider->next_module = new_module_ptr;
	}
	else {
		do {
			module_slider = module_slider->next_module;
		} while(module_slider->next_module != NULL);
		module_slider->next_module = new_module_ptr;
	}

	/* Add another module to the number of modules connected */
	mother->number_of_modules_loaded ++;

	g_print("loaded.\n");

	return TRUE;
}
