#include <gtk/gtk.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "define.h"
#include "../client_basic_modules/common/module.h"
#include "edit_layout.h"
#include "./art/empty_square.xpm"

void update_game_display(struct mother_hold*, long);
void add_to_game_display_layout(struct mother_hold*, int, long, int);
void list_game_layout(struct mother_hold*);
void draw_empty_locations(struct mother_hold*);

void make_world(mother)
struct mother_hold *mother;
{
	struct node_module_type *module_slider;
	FILE *infile;
	char buff[512], *tmp, *ptr, *begining;
	char module_name[512];
	char module_vers[512];
	int location_of_image;
	int module_id;
	long row, col;
	int instance;
	/* This is hardcoding, should use a node list instead. */
	char module_list_name[150][512];
	char module_list_vers[150][512];
	int module_list_ref[150];
	int number_of_reference_modules;
	int module_count;
	GdkGC *gc;
	GdkRectangle update_rect;
	long number_of_elements_so_far;
	long number_of_elements_total;

//	g_print("Inside make world.\n");
	g_print("Module version conflict warnings have been removed for now.\n");

	/* Load the playing board. */
    ptr = getenv("HOME");
    strcpy(buff, ptr);
    strcat(buff, "/.robot_race/world.brd");
    infile = fopen(buff, "r");

	g_print("*** Loading up game board.\n");

	/* display the progress bar window to show the loading speed... */
	gtk_window_set_title (GTK_WINDOW(
  			mother->server_form.tab2.design_progress_bar_window),
			"Loading up game layout...");
	gtk_widget_show(mother->server_form.tab2.design_progress_bar_window);

	/* we already know the world size, ignore first line of file */
	/* load the world size */
	fgets(buff, 80, infile);

	/* create a world pixmap this large to draw on */
	mother->main_form.game_display_pixmap =
			gdk_pixmap_new(
					mother->main_form.main_window->window,
					mother->main_form.width * 40,
					mother->main_form.height * 40,
					-1);

g_print("[DEBUG] This bitmap has no *known* value... _could_be_ a memory.\n");
g_print("[DEBUG] leak or at least future source of problems (maybe) [or not].\n");
/*
	mother->main_form.game_display_bitmap =
			gdk_pixmap_new(
					mother->main_form.main_window->window,
					mother->main_form.width * 40,
					mother->main_form.height * 40,
					1);
*/
    /* add the image to the scroll window of the main form */
/*
	gtk_pixmap_set(
			GTK_PIXMAP(mother->main_form.game_display_gtkpixmap),
			mother->main_form.game_display_pixmap,
			mother->main_form.game_display_bitmap);
*/
	/* store module description lines for later use */
	fgets(buff, 80, infile);
	number_of_reference_modules = 0;
	while(strcmp(buff, "listing start:\n")) {
		begining = buff;
		ptr = strstr(begining, " ");
		tmp = ptr + 1;
		ptr[0] = 0;
		/* The above 4 lines got rid of 'module: ' */

		begining = tmp;
		ptr = strstr(begining, ",");
		tmp = ptr + 2;
		ptr[0] = 0;
		strcpy(module_name, begining);

		begining = tmp;
		ptr = strstr(begining, ",");
		tmp = ptr + 2;
		ptr[0] = 0;
		strcpy(module_vers, begining);

		begining = tmp;
		module_id = atoi(tmp);

		g_print("Module identified: '%s', version: '%s', ref# %d\n",
				module_name, module_vers, module_id);

		strcpy(module_list_name[number_of_reference_modules], module_name);
		strcpy(module_list_vers[number_of_reference_modules], module_vers);
		module_list_ref[number_of_reference_modules] = module_id;
		number_of_reference_modules++;

		fgets(buff, 80, infile);
	}

	/* get the number of elements in the layout description */
	fgets(buff, 80, infile);
	number_of_elements_total = atol(buff);

	/* add each element one by one */
	number_of_elements_so_far = 0;
	fgets(buff, 80, infile);
	while(!feof(infile)) {

		/* find first value */
		begining = buff;
		ptr = strstr(begining, " ");
		tmp = ptr + 1;
		ptr[0] = 0;
		/* use first value */
		module_id = atoi(begining);

		/* find second value */
		begining = tmp;
		ptr = strstr(begining, " ");
		tmp = ptr + 1;
		ptr[0] = 0;
		/* use second value */
		col = atol(begining);

		/* find third value */
		begining = tmp;
		ptr = strstr(begining, " ");
		tmp = ptr + 1;
		ptr[0] = 0;
		/* use third value */
		row = atol(begining);

		/* find fouth value (already found) */
		begining = tmp;
		instance = atoi(begining);

		/**
		 * Add this element to our storeage & to the gui
		 */

		/* Find which element to draw */
		module_count = 0;
		location_of_image = 0;
		module_slider = mother->module_head;
		while(module_slider) {
			if(!strcmp(module_slider->name+1, module_list_name[module_id]+1)) {
				if(!strcmp(module_slider->info->version, module_list_vers[module_id])) {
					/* ok, name and version are the same, load it */
					location_of_image += instance;
					break;
				}
				else {
/*
					g_print("Warning: module versions don't match. '%s:%s', '%s:%s'\n",
						module_slider->name,
						module_slider->info->version,
					   	module_list_name[module_id],
					   	module_list_vers[module_id]);
					g_print("Warning: Trying to load anyways.\n");
*/
					/* ok, names are the same, try and load it */
					location_of_image += instance;
					break;
				}
			}

			module_count++;
			location_of_image += module_slider->info->number_of_small_images;
			module_slider = module_slider->next_module;
		}
		if(!module_slider) {
			g_print("Error: No module is loaded which matches the layout description.\n");
			g_print("Error: Load failed, giving up.\n");
			return;
		}
		/* add this element to our data */
		add_to_game_display_layout(
				mother, module_count,
				(long)(row * mother->main_form.width + col), instance);

		/* update this location on our drawing */
		update_game_display(mother, (long)(row * mother->main_form.width + col));

		/* Update our progress bar so the user knows how much time is left. */
		number_of_elements_so_far++;
		gtk_progress_bar_update(
				GTK_PROGRESS_BAR(mother->server_form.tab2.design_progress_bar),
				number_of_elements_so_far / (float)number_of_elements_total);
		/* update the spot which was drawn to */
	    update_rect.x = 0;
		update_rect.y = 0;
		update_rect.width = 250;
		update_rect.height = 100;
		gtk_widget_draw(
				mother->server_form.tab2.design_progress_bar,
				&update_rect);

		fgets(buff, 80, infile);
	}

	fclose(infile);

//	list_game_layout(mother);
	draw_empty_locations(mother);

    /* add the image to the scroll window of the main form */
	gtk_pixmap_set(
			GTK_PIXMAP(mother->main_form.game_display_gtkpixmap),
			mother->main_form.game_display_pixmap,
			mother->main_form.game_display_bitmap);

	g_print("*** Done loading up game board.\n");

	g_print("*** Making a back up copy of the game board.\n");
	/* create a world pixmap this large to draw on */
	mother->main_form.game_display_pixmap_backup =
			gdk_pixmap_new(
					mother->main_form.main_window->window,
					mother->main_form.width * 40,
					mother->main_form.height * 40,
					-1);
	gc = gdk_gc_new(mother->main_form.game_display_pixmap);
//    gdk_gc_set_clip_mask(
//			gc,
//			mother->main_form.game_display_bitmap);
	gdk_gc_set_clip_origin(gc, 0, 0);
	gdk_draw_pixmap(
			mother->main_form.game_display_pixmap_backup,
			gc,
			mother->main_form.game_display_pixmap,
			0, 0, /* destination */
			0, 0, /* location on the FROM pixmap to start copying from */
			mother->main_form.width * 40,
			mother->main_form.height * 40);
	g_print("*** Finished.\n");

	/* hide our progress window */
	gtk_widget_hide(mother->server_form.tab2.design_progress_bar_window);
}

void add_to_game_display_layout(mother, module_id, to_where, instance)
struct mother_hold *mother;
int module_id;
long to_where;
int instance;
{
//	node_module_type *module_slider;
//	int number_of_images;
	node_layout_ptr new_element;
	node_layout_ptr layout_slider;

	/**
	 * Add this element to our design layout listing
	 */ 
	/* Allocate memory for the node */
	new_element = (node_layout_ptr) calloc (1, sizeof(node_layout_type));
	/* Fill in the new information about the module */
	new_element->id = module_id;
	new_element->x = to_where % mother->main_form.width;
	new_element->y = to_where / mother->main_form.width;
	new_element->location = to_where;
	new_element->instance = instance;
	new_element->display_depth = get_depth_from_id(mother, new_element->id);
	new_element->next_element = NULL;

	/* Move to the end of the node list & attach */
	layout_slider = mother->game_head;
	if(layout_slider == NULL) {
		/* This is the first element */
		mother->game_head = new_element;
	}
	else if(layout_slider->next_element == NULL) {
		/* There is only one element, does this go before or after it? */
		if(layout_slider->display_depth >= new_element->display_depth) {
			/* place the new node before this one */
			new_element->next_element = mother->game_head;
			mother->game_head = new_element;
		}
		else {
			/* after this node */
			layout_slider->next_element = new_element;
		}
	}
	else {
		/* There are at least two elements, try to find the current location */
		/* and add appropriately according to depth drawing order. If */
		/* the location is unoccupied in the listing, add this */
		/* new node to the appropriate place in the list end. */
		layout_slider = mother->game_head;
		/* First case is special. */
		if(layout_slider->location == new_element->location) {
			/* If this drawing depth is less than the stored one then this */
			/* new node should be stored before it. There are 4 possible */
			/* depths so each must be checked for. */
			if(layout_slider->display_depth >= new_element->display_depth) {
				/* this new node is going to be the head node. */
				new_element->next_element = mother->game_head;
				mother->game_head = new_element;
			}
			else {
				while(layout_slider->next_element->location == new_element->location) {
					if(layout_slider->next_element->display_depth >= new_element->display_depth) {
						break;
					}
					else {
						layout_slider = layout_slider->next_element;
						if(layout_slider->next_element == NULL) {
							break;
						}
					}
				}
				/* Attach node here. */
				new_element->next_element = layout_slider->next_element;
				layout_slider->next_element = new_element;
			}
		}
		else {
			/* Find our element id in the node list */
			while(layout_slider->next_element->location != new_element->location) {
				layout_slider = layout_slider->next_element;
				if(layout_slider->next_element == NULL) {
					/* Special case, we have run off the end of the node list */
					layout_slider->next_element = new_element;
//list_game_layout(mother);
					return;
				}
			}
			while(layout_slider->next_element->location == new_element->location) {
				if(layout_slider->next_element->display_depth >= new_element->display_depth) {
					break;
				}
				else {
					layout_slider = layout_slider->next_element;
					if(layout_slider->next_element == NULL) {
						break;
					}
				}
			}
			/* Attach node here. */
			new_element->next_element = layout_slider->next_element;
			layout_slider->next_element = new_element;
		}
	}

//	list_game_layout(mother);
}

void list_game_layout(mother)
struct mother_hold *mother;
{
	struct node_layout_type *layout_slider;
 
	layout_slider = mother->game_head;
	g_print("Listing game layout description.\n");
	while(layout_slider) {
		g_print("- Element Found of type: %d, at (%ld,%ld)(%ld), instance #%d, depth %d\n",
				layout_slider->id,
				layout_slider->x,
				layout_slider->y,
				layout_slider->location,
				layout_slider->instance,
				layout_slider->display_depth);
 
		/* move on to next element */
		layout_slider = layout_slider->next_element;
	}
	g_print("done.\n");
}                                                                                         

void update_game_display(mother, where)
struct mother_hold *mother;
long where;
{
	node_module_type *module_slider;
	node_layout_ptr layout_slider;
	int module_count;

	GdkColormap	*colormap;
	GdkPixmap	*pixmap;
	GdkBitmap	*bitmap;
	GdkGC		*gc;
	GdkGC		*main_gc;

//	g_print("- adding pixmap game display\n");

	/* Find the location in the description nodes... */
	layout_slider = mother->game_head;
	while(layout_slider) {
		if(layout_slider->location == where) {
			break;
		}
		layout_slider = layout_slider->next_element;
	}

	/* Check for errors */
	if(!layout_slider) {
		g_print("This should not be reached, can't find location in game linklist.\n");
		return;
	}

	/* Create the next pixmap to add to this location. */
	colormap = gtk_widget_get_colormap(mother->main_form.main_window);
	pixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL, colormap,
			&bitmap, NULL, empty_square_xpm);

	/**
	 * For each node find the related module and add the image to the new
	 * pixmap.
	 */
	while(layout_slider->location == where) {
		/* Find the related module. */
		module_count = 0;
		module_slider = mother->module_head;
		while(module_slider) {
			if(module_count == layout_slider->id) {
				break;
			}
			/* check the next module */
			module_count++;
			module_slider = module_slider->next_module;
		}

		gc = gdk_gc_new(module_slider->info->list_of_large_images[layout_slider->instance]);
	    gdk_gc_set_clip_mask(
				gc,
				module_slider->info->list_of_large_masks[layout_slider->instance]);
		gdk_gc_set_clip_origin(gc, 0, 0);

		/* Add this pixmap to the image that will be added. */
//		g_print("Adding instance %d, of module %d\n",
//				layout_slider->instance, module_count);
		gdk_draw_pixmap(
				pixmap, gc,
				module_slider->info->list_of_large_images[layout_slider->instance],
				0, 0, /* destination */
				0, 0, /* location on the FROM pixmap to start copying from */
				40, 40 /* size of image */);

		/* Move on to next node */
		layout_slider = layout_slider->next_element;
		if(layout_slider == NULL) {
			/* We have run out of elements. */
			break;
		}
	}

	/* add the image to the game display pixmap */
	main_gc = gdk_gc_new(pixmap);
    gdk_gc_set_clip_mask(main_gc, bitmap);
	gdk_gc_set_clip_origin(main_gc,
			(where % mother->main_form.width) * 40, /* destination x */
			(where / mother->main_form.width) * 40);/* destination y */
	gdk_draw_pixmap(
			mother->main_form.game_display_pixmap, main_gc,
			pixmap,
			0, 0, /* location on the FROM pixmap to start copying from */
			(where % mother->main_form.width) * 40, /* destination x */
			(where / mother->main_form.width) * 40, /* destination y */
			40, 40 /* size of image */);

	/* Free up resources, should we be doing this??? */
//	  free up the style?
//    gdk_gc_unref(gc);
//    gdk_pixmap_unref(pixmap);
//    gdk_bitmap_unref(bitmap);

}

void draw_empty_locations(struct mother_hold *mother) {
	node_layout_ptr layout_slider;
	int find_missing_ptr;
	int max_location;

	GdkColormap	*colormap;
	GdkPixmap	*pixmap;
	GdkBitmap	*bitmap;
	GdkGC		*main_gc;

	max_location = mother->main_form.width * mother->main_form.height;
	for(find_missing_ptr = 0; find_missing_ptr < max_location; find_missing_ptr++) {
		/* Does this location have any elements in it? */
		layout_slider = mother->game_head;
		while(layout_slider) {
			if(layout_slider->location == find_missing_ptr) {
				break;
			}
			layout_slider = layout_slider->next_element;
		}
		if(!layout_slider) {
			/* since the node list is in order we can find missing */
			/* locations rather easily. */

			/* Create the next pixmap to add to this location. */
			colormap = gtk_widget_get_colormap(mother->main_form.main_window);
			pixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL, colormap,
					&bitmap, NULL, empty_square_xpm);

			/* add the image to the game display pixmap */
			main_gc = gdk_gc_new(pixmap);
		    gdk_gc_set_clip_mask(main_gc, bitmap);
			gdk_gc_set_clip_origin(main_gc,
					(find_missing_ptr % mother->main_form.width) * 40, /* destination x */
					(find_missing_ptr / mother->main_form.width) * 40);/* destination y */
			gdk_draw_pixmap(
					mother->main_form.game_display_pixmap, main_gc,
					pixmap,
					0, 0, /* location on the FROM pixmap to start copying from */
					(find_missing_ptr % mother->main_form.width) * 40, /* destination x */
					(find_missing_ptr / mother->main_form.width) * 40, /* destination y */
					40, 40 /* size of image */);
		}
	}
}
