#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "netutil.h"

/* Read "n" bytes from a descriptor
 * Use in place of read() when fd is a stream socket
 */

int readn( fd, ptr, nbytes)
register int fd;
register char *ptr;
register int nbytes;
{
	int nleft, nread;
	
	nleft = nbytes;
	while (nleft > 0)
	{
		nread = read(fd, ptr, nleft);
		if (nread < 0) {
			printf("Socket read error!\n");
			exit(0);
			return (nread);		/*error, return <0 */
		}
		else if (nread == 0) {
//			printf("*EOF*EOF*EOF*\n");
			break;			/*EOF*/
		}

		nleft -= nread;
		ptr += nread;
	}
	return (nbytes - nleft);	/* return >= 0 */
}


/* 
 * Write "n" bytes to a descriptor.
 * Use in place of write() when fd is a stream socket
 */

int writen (fd, ptr, nbytes)
register int fd;
register char *ptr;
register int nbytes;
{
	int nleft, nwritten;
	
	nleft = nbytes;
	while (nleft > 0)
	{
		nwritten = write (fd, ptr, nleft);
		if (nwritten <= 0)
			return (nwritten);	/*error*/
		
		nleft -= nwritten;
		ptr += nwritten;
	}
	return (nbytes - nleft);
}


/* 280
 * Read a line from a descriptor. Read the line one byte at a time, 
 * looking for the newline. We store the newline in the buffer, 
 * then follow it with a null (the same as fgets(3)).
 * We return the number of characters up to, but not including
 * the null ( the same as (stelen(3)).
 */

int readline (fd, ptr, maxlen)
register int fd;
register char *ptr;
register int maxlen;
{
	int n, rc;
	char c;

	for (n = 1; n < maxlen; n++)
	{
		if ((rc = read (fd, &c, 1)) == 1)
		{
/*			*ptr++ = c;							*/
/*			if (( c == '\n' ) || ( c == '\r' ))	*/
/*				break;							*/
			if (c == '\n')
				break;
			if (c != '\r')
				*ptr++ = c;
		}
		else if (rc == 0)
		{
			if (n == 1)
				return (0);	/* EOF, no data read */
			else
				break;
		}
		else
			return (-1);		/* error */
	}

	*ptr = 0;
	return (n);
}

int writestr(fd, ptr)
register int fd;
register char *ptr;
{
	return writen(fd, ptr, strlen(ptr));
}
