/* utilitity routine, 279 */

#ifndef NETUTIL
#define NETUTIL

/* Read "n" bytes from a descriptor
 * Use in place of read() when fd is a stream socket
 */
int readn(
 register int fd,
 register char *ptr,
 register int nbytes
);


/* 
 * Write "n" bytes to a descriptor.
 * Use in place of write() when fd is a stream socket
 */
int writen (
 register int fd,
 register char *ptr,
 register int nbytes
);


/* 280
 * Read a line from a descriptor. Read the line one byte at a time, 
 * looking for the newline. We store the newline in the buffer, 
 * then follow it with a null (the same as fgets(3)).
 * We return the number of characters up to, but not including
 * the null ( the same as (stelen(3)).
 */

int readline (
 register int fd,
 register char *ptr,
 register int maxlen
);

int writestr(
 register int fd,
 register char *ptr
);

#endif /* NETUTIL */
