#include <string.h>
#include <stdlib.h>
#include "define.h"
#include "../server_basic_modules/common/recvenum.h"
#include "netutil.h"
#include "parsecli.h"
#include "parseser.h"
#include "../server_basic_modules/common/adminvar.h"
#include "loadmod.h"
#include "server_form.h"
#include "edit_layout.h"
#include "callbacks.h"
#include "loadup.h"

void parse_client(struct mother_hold *mother, char *newstring) {
	int length, ctr;
	char tosend[512], buff[512];
	char *ptr1, *ptr2;
	int arg_count = 0, tmp1, tmp2;
	char *args[11], *ptrs[5];

	/* args is an array of pointers to arguments */
	/* ptrs are points in the original string where the args started */

	if(newstring[0] == '/') {
		/* Strip off each argument, this may be pointless so we'll */
		/* only strip off 10 arguments max */
		ptr1 = newstring;
		ptr2 = strstr(newstring, " ");
		while(ptr2) {
			tmp1 = strlen(ptr1);
			tmp2 = strlen(ptr2);
			strncpy(buff, ptr1, tmp1 - tmp2);
			buff[tmp1-tmp2] = 0;
			args[arg_count++] = g_strdup(buff);

			/* Stop if the next argument would be our last */
			if(arg_count == 10) {
				break;
			}
			if(arg_count <= 5) {
				ptrs[arg_count-1] = ptr1;
			}

			ptr1 = ++ptr2;
			ptr2 = strstr(ptr1, " ");
		}
		/* If this is a \n replace with 0 */
		ptr1[strlen(ptr1)] = 0;

		/* Last argument, or maybe first, done here, it copies to EOL */
		args[arg_count++] = g_strdup(ptr1);
		if(arg_count <= 5) {
			ptrs[arg_count-1] = ptr1;
		}
/*
	for(ctr = 0; ctr < arg_count; ctr ++) {
		printf("args[%d] is '%s'\n", ctr, args[ctr]);
	}
*/
		if(arg_count) {
			if(!strcmp(args[0], "/me")) {
				tosend[0] = C_EMOTE;
				tosend[1] = strlen(ptrs[1]) + 1;
				strcpy(tosend+2, ptrs[1]);
				writen(mother->socket, tosend, strlen(ptrs[1])+3);
			}
			else if(!strcmp(args[0], "/msg")) {
				tosend[0] = C_WHISPER;
				tosend[1] = get_id_from_name(args[1], mother);
				tosend[2] = strlen(ptrs[2]) + 1;
				strcpy(tosend+3, ptrs[2]);
				writen(mother->socket, tosend, strlen(ptrs[2])+4);
			}
			else if(!strcmp(args[0], "/nick")) {
				tosend[0] = C_CHANGE_NICK;
				tosend[1] = strlen(args[1]) + 1;
				strcpy(tosend+2, args[1]);
				writen(mother->socket, tosend, strlen(args[1])+3);
			}
			else if(!strcmp(args[0], "/passwd")) {
				tosend[0] = C_ADMIN_GAIN_ACCESS;
				tosend[1] = strlen(args[1]) + 1;
				strcpy(tosend+2, args[1]);
				writen(mother->socket, tosend, strlen(args[1])+3);
			}
			else if(!strcmp(args[0], "/load")) {
				loadup_command_file(mother, args[1]);
			}
			else if(!strcmp(args[0], "/loaddesign")) {
				gtk_file_selection_set_filename(
					GTK_FILE_SELECTION(
							mother->server_form.tab2.file_selection_design_load),
							args[1]);
				file_select_design_load_ok_clicked(NULL, mother);
			}
			else if(!strcmp(args[0], "/startgame")) {
				on_start_game_activate(NULL, mother);
			}
			else if(!strcmp(args[0], "/nonplayer")) {
				tosend[0] = C_NOT_A_PLAYER;
				writen(mother->socket, tosend, 1);
			}
			else if(!strcmp(args[0], "/isplayer")) {
				tosend[0] = C_IS_A_PLAYER;
				writen(mother->socket, tosend, 1);
			}
			else if(!strcmp(args[0], "/facing")) {
				tosend[0] = C_SPAWNING_DIRECTION;
				tosend[1] = atoi(args[1]);
				writen(mother->socket, tosend, 2);
			}
			else if(!strcmp(args[0], "/loadmod")) {
				/* If the module loads successfully we need to */
				/* update the server_form configure tab */
				if(load_module(mother, args[1])) {
					update_server_form_edit(mother);
				}
			}
			else if(!strcmp(args[0], "/pcards")) {
				tosend[0] = C_P_CARD_SELECTION;
				tosend[1] = atoi(args[1]);
				tosend[2] = atoi(args[2]);
				tosend[3] = atoi(args[3]);
				tosend[4] = atoi(args[4]);
				tosend[5] = atoi(args[5]);
				tosend[6] = atoi(args[6]);
				writen(mother->socket, tosend, 7);
			}
/*			else if(!strcmp(args[0], "/quit")) {
				tosend[0] = _QUIT;
				writen(mother->socket, tosend, 1);
			}
*/			else if(!strcmp(args[0], "/help")) {
			}
		}
		/* else malformed command */
	}
	else {
		/* It isn't a command so it must be chat */
		length = strlen(newstring)+1;
		tosend[0] = C_TALK;
		tosend[1] = length;
		strcpy(tosend+2, newstring);
		tosend[length+1] = 0;
		writen(mother->socket, tosend, length+2);
	}

	/* Free up used memory */
	for(ctr = 0; ctr < arg_count; ctr ++) {
		g_free(args[ctr]);
	}
}

/* Finds a user nick and returns their id #, not case sensitive */
int get_id_from_name(char *usernick, struct mother_hold *mother) {
	node_user_ptr slider;

	slider = mother->user_head;
	while(slider != NULL) {
		if(!strcasecmp(usernick, slider->nick)) {
			return slider->id;
		}
		slider = slider->next_user;
	}
	return -1;
}
