#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "callbacks.h"
#include "support.h"

#include "donothing.h"
#include "define.h"
#include "./art/p_card.xpm"
#include "./art/locked0.xpm"

#include "./art/p_card_backup.xpm"
#include "./art/p_card_clockwise.xpm"
#include "./art/p_card_counter_clockwise.xpm"
#include "./art/p_card_forward_one.xpm"
#include "./art/p_card_forward_three.xpm"
#include "./art/p_card_forward_two.xpm"
#include "./art/p_card_u_turn.xpm"

void load_up_program_cards(struct mother_hold*);

GtkWidget*
create_pcard_select_form(struct mother_hold *mother)
{
	GtkWidget *pcard_select_form;
	GtkWidget *main_vbox;
	GtkWidget *hbox_level1;
	GtkWidget *hbox_level2;
	GtkWidget *vbox_select_card[5];
	GtkWidget *vbox_pickme_card[9];
	GtkWidget *ok_button;
	GdkPixmap *pixmap1, *pixmap2;
	GdkBitmap *bitmap1, *bitmap2;
	GdkColormap *colormap;
	int ctr;

	pcard_select_form = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (pcard_select_form), "pcard_select_form", pcard_select_form);
	gtk_window_set_title (GTK_WINDOW (pcard_select_form), _("Program Card Select"));
	gtk_window_set_default_size (GTK_WINDOW (pcard_select_form), 325, 188);
	gtk_widget_hide(pcard_select_form);

	gtk_signal_connect(GTK_OBJECT(pcard_select_form), "delete_event",
			GTK_SIGNAL_FUNC(do_nothing), (gpointer)mother);
	gtk_signal_connect(GTK_OBJECT(pcard_select_form), "destroy",
			GTK_SIGNAL_FUNC(do_nothing), (gpointer)mother);

	main_vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (main_vbox);
	gtk_container_add(
			GTK_CONTAINER(pcard_select_form), main_vbox);

	hbox_level1 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_level1);
	gtk_box_pack_start (
		GTK_BOX (main_vbox), hbox_level1, FALSE, FALSE, 0);

	hbox_level2 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_level2);
	gtk_box_pack_start (
		GTK_BOX (main_vbox), hbox_level2, FALSE, FALSE, 0);

	for(ctr = 0; ctr < 5; ctr ++) {
		mother->main_form.toggle_select[ctr] = gtk_toggle_button_new();
		gtk_widget_show(mother->main_form.toggle_select[ctr]);
		gtk_box_pack_start(GTK_BOX(hbox_level1),
				mother->main_form.toggle_select[ctr], FALSE, FALSE, 0);
		gtk_signal_connect(GTK_OBJECT(
				mother->main_form.toggle_select[ctr]),
				"clicked",
                GTK_SIGNAL_FUNC(check_pcards_selected),
                (gpointer)mother);
	}
	for(ctr = 0; ctr < 9; ctr ++) {
		mother->main_form.toggle_pickme[ctr] = gtk_toggle_button_new();
		gtk_widget_show(mother->main_form.toggle_pickme[ctr]);
		gtk_box_pack_start(GTK_BOX(hbox_level2),
				mother->main_form.toggle_pickme[ctr], FALSE, FALSE, 0);
		gtk_signal_connect(GTK_OBJECT(
				mother->main_form.toggle_pickme[ctr]),
				"clicked",
                GTK_SIGNAL_FUNC(check_pcards_selected),
                (gpointer)mother);
	}

	colormap = gtk_widget_get_colormap(pcard_select_form);
	pixmap1 = gdk_pixmap_colormap_create_from_xpm_d(
			NULL, colormap, &bitmap1,
			NULL, locked0_xpm);

	colormap = gtk_widget_get_colormap(pcard_select_form);
	pixmap2 = gdk_pixmap_colormap_create_from_xpm_d(
			NULL, colormap, &bitmap2,
			NULL, p_card_xpm);

	/**
	 * create program cards to choose from
	 *
	 * add to vbox:
	 * gtkpixmap
	 * label
	 *
	 * add to togglebutton:
	 * vbox
	 */
	for(ctr = 0; ctr < 5; ctr ++) {
		vbox_select_card[ctr] = gtk_vbox_new(FALSE, 0);
		gtk_widget_show(vbox_select_card[ctr]);

		mother->main_form.locked[ctr] = gtk_pixmap_new(pixmap1, bitmap1);
		gtk_widget_show(mother->main_form.locked[ctr]);

  		gtk_box_pack_start(GTK_BOX(vbox_select_card[ctr]),
				mother->main_form.locked[ctr], FALSE, FALSE, 0);

		mother->main_form.select[ctr] = gtk_pixmap_new(pixmap2, bitmap2);
		gtk_widget_show(mother->main_form.select[ctr]);

  		gtk_box_pack_start(GTK_BOX(vbox_select_card[ctr]),
				mother->main_form.select[ctr], FALSE, FALSE, 0);

		mother->main_form.label_select[ctr] = gtk_label_new("");
		gtk_widget_show(
				mother->main_form.label_select[ctr]);

  		gtk_box_pack_start(GTK_BOX(vbox_select_card[ctr]),
				mother->main_form.label_select[ctr], FALSE, FALSE, 0);

		gtk_container_add(
				GTK_CONTAINER(mother->main_form.toggle_select[ctr]),
				vbox_select_card[ctr]);
	}

	/**
	 * create program cards to choose from
	 *
	 * add to vbox:
	 * gtkpixmap
	 * label
	 *
	 * add to togglebutton:
	 * vbox
	 */
	for(ctr = 0; ctr < 9; ctr ++) {
		vbox_pickme_card[ctr] = gtk_vbox_new(FALSE, 0);
		gtk_widget_show(vbox_pickme_card[ctr]);

		mother->main_form.pickme[ctr] = gtk_pixmap_new(pixmap2, bitmap2);
		gtk_widget_show(mother->main_form.pickme[ctr]);

  		gtk_box_pack_start(GTK_BOX(vbox_pickme_card[ctr]),
				mother->main_form.pickme[ctr], FALSE, FALSE, 0);

		mother->main_form.label_pickme[ctr] = gtk_label_new("111");
		gtk_widget_show(
				mother->main_form.label_pickme[ctr]);

  		gtk_box_pack_start(GTK_BOX(vbox_pickme_card[ctr]),
				mother->main_form.label_pickme[ctr], FALSE, FALSE, 0);

		gtk_container_add(
				GTK_CONTAINER(mother->main_form.toggle_pickme[ctr]),
				vbox_pickme_card[ctr]);
	}

	gdk_pixmap_unref(pixmap1);
//	gdk_bitmap_unref(bitmap1);
	gdk_pixmap_unref(pixmap2);
//	gdk_bitmap_unref(bitmap2);

	mother->main_form.shutdown_toggle =
			gtk_toggle_button_new_with_label("SHUTDOWN");
	gtk_widget_show(mother->main_form.shutdown_toggle);
	gtk_box_pack_start(
			GTK_BOX(main_vbox), mother->main_form.shutdown_toggle,
		   	FALSE, FALSE, 0);

	ok_button = gtk_button_new_with_label("Send Selection");
	gtk_widget_show(ok_button);
	gtk_signal_connect(GTK_OBJECT(ok_button), "clicked",
                      GTK_SIGNAL_FUNC(send_pcards_selected),
                      (gpointer)mother);
	gtk_box_pack_start(
			GTK_BOX(main_vbox), ok_button, FALSE, FALSE, 0);

	load_up_program_cards(mother);

	return pcard_select_form;
}

void load_up_program_cards(mother)
struct mother_hold *mother;
{
	GdkColormap	*colormap;

	colormap = gtk_widget_get_colormap(mother->main_form.main_window);
	mother->main_form.program_cards_pixmap[0] =
			gdk_pixmap_colormap_create_from_xpm_d(
					NULL, colormap,
					&mother->main_form.program_cards_bitmap[0],
					NULL, p_card_u_turn_xpm);

	colormap = gtk_widget_get_colormap(mother->main_form.main_window);
	mother->main_form.program_cards_pixmap[1] =
			gdk_pixmap_colormap_create_from_xpm_d(
					NULL, colormap,
					&mother->main_form.program_cards_bitmap[1],
					NULL, p_card_counter_clockwise_xpm);

	colormap = gtk_widget_get_colormap(mother->main_form.main_window);
	mother->main_form.program_cards_pixmap[2] =
			gdk_pixmap_colormap_create_from_xpm_d(
					NULL, colormap,
					&mother->main_form.program_cards_bitmap[2],
					NULL, p_card_clockwise_xpm);

	colormap = gtk_widget_get_colormap(mother->main_form.main_window);
	mother->main_form.program_cards_pixmap[3] =
			gdk_pixmap_colormap_create_from_xpm_d(
					NULL, colormap,
					&mother->main_form.program_cards_bitmap[3],
					NULL, p_card_backup_xpm);

	colormap = gtk_widget_get_colormap(mother->main_form.main_window);
	mother->main_form.program_cards_pixmap[4] =
			gdk_pixmap_colormap_create_from_xpm_d(
					NULL, colormap,
					&mother->main_form.program_cards_bitmap[4],
					NULL, p_card_forward_one_xpm);

	colormap = gtk_widget_get_colormap(mother->main_form.main_window);
	mother->main_form.program_cards_pixmap[5] =
			gdk_pixmap_colormap_create_from_xpm_d(
					NULL, colormap,
					&mother->main_form.program_cards_bitmap[5],
					NULL, p_card_forward_two_xpm);

	colormap = gtk_widget_get_colormap(mother->main_form.main_window);
	mother->main_form.program_cards_pixmap[6] =
			gdk_pixmap_colormap_create_from_xpm_d(
					NULL, colormap,
					&mother->main_form.program_cards_bitmap[6],
					NULL, p_card_forward_three_xpm);
}
