#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "clinet.h"
#include "network.h"
#include "define.h"
#include "parsecli.h"
#include "parseser.h"
#include "spawnsel.h"
#include "pcardsel.h"
#include "glogin.h"

#include "interface.h"
#include "support.h"
#include "config.h"

void init(struct mother_hold*);

int main(int argc, char *argv[]) {
	struct mother_hold mother;
	char buff[512];

//  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
//  textdomain (PACKAGE);

	gtk_set_locale ();
	gtk_init (&argc, &argv);

	add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
	add_pixmap_directory (PACKAGE_SOURCE_DIR "/art");

	/* Create the gui forms */
	mother.main_form.main_window = create_main_form(&mother);
	mother.main_form.pcard_select_form = create_pcard_select_form(&mother);
	mother.main_form.spawn_select_form = create_spawn_select_form(&mother);
	mother.main_form.login_form = create_login_form (&mother);
	mother.main_form.news_form = create_news_form (&mother);
	mother.status_form = create_status_form (&mother);
	mother.server_form.main_window = create_server_form (&mother);

	/* Only show the forms if the connection succeeded. */
	gtk_widget_show(mother.main_form.main_window);
//	gtk_widget_show(mother.status_form.main_window);
//	gtk_widget_hide(mother.main_form.pcard_select_form);
//	gtk_widget_hide(mother.main_form.spawn_select_form);

	/* Some default values */
	init(&mother);

	/* Load up all modules available */
	strcpy(buff, "/load ");
	strcat(buff, getenv("HOME"));
	strcat(buff, "/.robot_race/client.com");
	parse_client(&mother, buff);

	if(argc < 2) {
//		g_free(mother.hostname);
//		g_free(mother.port);
//		printf("Syntax is: ./rrclient nickname [hostname] [port]\n");
	}
	else {
		g_free(mother.usernick);
		mother.usernick = g_strdup(argv[1]);
		if(argc >= 3) {
			g_free(mother.hostname);
			mother.hostname = g_strdup(argv[2]);
		}
		if(argc == 4) {
			g_free(mother.hostport);
			mother.hostport = g_strdup(argv[3]);
		}

		mother.socket = cli_connect(
				mother.hostname, mother.hostport, mother.usernick);

		if(mother.socket) {
			gtk_text_insert(
					GTK_TEXT(mother.main_form.chat_display),
					NULL, NULL, NULL,
				    "*** Connection Succeeded...",
					strlen("*** Connection Succeeded..."));

			/* Add the socket to be watched by GTK */
			gdk_input_add(mother.socket, GDK_INPUT_READ, parse_server, &mother);
		}
		else {
			gtk_text_insert(
					GTK_TEXT(mother.main_form.chat_display),
					NULL, NULL, NULL,
					"*** Connection to server failed...",
					strlen("*** Connection to server failed..."));
		}
	}

	gtk_main ();

	return 0;
}

/* set some initial values */
void init(struct mother_hold *mother) {
	gtk_entry_set_text(
			GTK_ENTRY(mother->main_form.login_nick), getenv("LOGNAME"));
	gtk_entry_set_text(
			GTK_ENTRY(mother->main_form.login_host), "127.0.0.1");
	gtk_entry_set_text(
			GTK_ENTRY(mother->main_form.login_port), "2346");

	mother->usernick = g_strdup(getenv("LOGNAME"));
	mother->hostname = g_strdup("127.0.0.1");
	mother->hostport = g_strdup("2346");

	mother->user_head = NULL;
	mother->game_head = NULL;
	mother->design_head = NULL;
	mother->robot_head = NULL;
	mother->server_head = NULL;
	mother->socket = 0;
}
