#include <gtk/gtk.h>
#include <string.h>
#include <stdio.h>

#include "define.h"
#include "../client_basic_modules/common/module.h"

void save_layout(mother, filename)
struct mother_hold *mother;
gchar *filename;
{
	struct node_module_type *module_slider;
	struct node_layout_type *layout_slider;
	int module_id;
	long max_row, max_col;
	FILE *outfile;
	char buff[512];
	long number_of_elements;

	/* Save the design view board. */
//	g_print("SAVING BOARD AS THIS:\n");
	g_print("SAVING BOARD:\n");

	outfile = fopen(filename, "w");
	if(!outfile) {
		return;
	}

	strcpy(buff, "Server Configuration: '");
	strcat(buff, filename);
	strcat(buff, "'");
	gtk_window_set_title(
			GTK_WINDOW (mother->server_form.main_window), buff);

	/* write the world size */
	max_row = gtk_spin_button_get_value_as_int(
			GTK_SPIN_BUTTON(mother->server_form.tab2.spin_world_button_y));
	max_col = gtk_spin_button_get_value_as_int(
			GTK_SPIN_BUTTON(mother->server_form.tab2.spin_world_button_x));
//	g_print("%ld %ld\n", max_col, max_row);
	sprintf(buff, "%ld %ld\n", max_col, max_row);
	fputs(buff, outfile);

	/* write out the module name, version, and number associated with each */
	module_id = 0;
	module_slider = mother->module_head;
	while(module_slider) {
//		g_print("module: %s, %s, %d\n",
//				module_slider->name,
//				module_slider->info->version,
//				module_id);
		sprintf(buff, "module: %s, %s, %d\n",
				module_slider->name,
				module_slider->info->version,
				module_id);
		fputs(buff, outfile);

		module_id++;
		module_slider = module_slider->next_module;
	}

//	g_print("listing start:\n");
	fputs("listing start:\n", outfile);

	/* count the number of elements and write this to the file */
	number_of_elements = 0;
	layout_slider = mother->design_head;
	while(layout_slider) {
		number_of_elements++;
		layout_slider = layout_slider->next_element;
	}
	sprintf(buff, "%ld\n", number_of_elements);
	fputs(buff, outfile);

	/* dump the layout to the file */
	layout_slider = mother->design_head;
	while(layout_slider) {
		/* find the module type associated with this type of element */
		module_id = 0;
		module_slider = mother->module_head;
		while(module_slider) {
			if(module_id == layout_slider->id) {
				break;
			}
			module_id++;
			module_slider = module_slider->next_module;
		}

		/* we have the module and the layout, write them down */
//		g_print("%d %ld %ld %d\n",
//				module_id,
//				layout_slider->x,
//				layout_slider->y,
//				layout_slider->instance);
		sprintf(buff, "%d %ld %ld %d\n",
				module_id,
				layout_slider->x,
				layout_slider->y,
				layout_slider->instance);
		fputs(buff, outfile);

		layout_slider = layout_slider->next_element;
	}

//	g_print("listing finished.\n");
//	fputs("listing finished.\n", outfile);

	fclose(outfile);
}
