#include <stdio.h>

/**
 * Displays as hex as many characters as indicated by num_chars_to_display
 * which are stored in the char* buffer.
 */
void show_as_hex(int num_chars_to_display, char buffer[]) {
	int ctr, warn = 0;
	unsigned char first, second;

	for(ctr = 0; ctr < num_chars_to_display; ctr ++) {
		first = second = (unsigned char)buffer[ctr];

		/* Display a warning for developers */
		if(first > 127) {
			warn = 1;
		}

		first /= 16;
		second -= (first * 16);

		if(first > 9)
			first = first - 10 + 'A';
		else
			first += '0';

		if(second > 9)
			second = second - 10 + 'A';
		else
			second += '0';

		printf("%c%c ", first, second);
	}
	printf("\n");

	if(warn) {
		printf("There is a char > 127, possibly this will require");
		printf(" special coding in a function.\n");
	}
}
