#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "callbacks.h"
#include "support.h"

#include "define.h"
#include "donothing.h"
#include "../server_basic_modules/common/recvenum.h"
#include "netutil.h"

#include "./art/arrow_n.xpm"
#include "./art/arrow_e.xpm"
#include "./art/arrow_s.xpm"
#include "./art/arrow_w.xpm"

void check_spawn_choice(GtkWidget *width, gpointer user_data) {
	struct mother_hold *mother;
	gchar tosend[512];
	int ctr;

	mother = (struct mother_hold*)user_data;

	gtk_widget_hide(mother->main_form.spawn_select_form);

	/* find the clicked toggle button */
	for(ctr = 0; ctr < 4; ctr ++) {
		if(gtk_toggle_button_get_active(
				GTK_TOGGLE_BUTTON(mother->main_form.toggle_spawn[ctr]))) {
			break;
		}
	}
	if(ctr == 4) {
		/* double click effect, ignore */
		return;
	}

	/* pop the toggle button back up */
	gtk_toggle_button_set_active(
			GTK_TOGGLE_BUTTON(mother->main_form.toggle_spawn[ctr]),
			FALSE);

	tosend[0] = C_SPAWNING_DIRECTION;
	tosend[1] = ctr;
	writen(mother->socket, tosend, 2);
}

GtkWidget*
create_spawn_select_form(struct mother_hold *mother)
{
	GtkWidget *spawn_select_form;
	GtkWidget *main_vbox;
	GtkWidget *hbox_level1;
	GdkPixmap *pixmap1;
	GdkBitmap *bitmap1;
	GdkColormap *colormap;
	int ctr;

	spawn_select_form = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (spawn_select_form), "spawn_select_form", spawn_select_form);
	gtk_window_set_title (GTK_WINDOW (spawn_select_form), _("Select Spawn Direction"));
	gtk_window_set_default_size (GTK_WINDOW (spawn_select_form), 323, 105);
	gtk_widget_hide(spawn_select_form);

	gtk_signal_connect(GTK_OBJECT(spawn_select_form), "delete_event",
			GTK_SIGNAL_FUNC(do_nothing), (gpointer)mother);
	gtk_signal_connect(GTK_OBJECT(spawn_select_form), "destroy",
			GTK_SIGNAL_FUNC(do_nothing), (gpointer)mother);

	main_vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (main_vbox);
	gtk_container_add(
			GTK_CONTAINER(spawn_select_form), main_vbox);

	hbox_level1 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_level1);
	gtk_box_pack_start (
		GTK_BOX (main_vbox), hbox_level1, FALSE, FALSE, 0);

	for(ctr = 0; ctr < 4; ctr ++) {
		mother->main_form.toggle_spawn[ctr] = gtk_toggle_button_new();
		gtk_widget_show(mother->main_form.toggle_spawn[ctr]);
		gtk_box_pack_start(GTK_BOX(hbox_level1),
				mother->main_form.toggle_spawn[ctr], FALSE, FALSE, 0);
		gtk_signal_connect(GTK_OBJECT(
				mother->main_form.toggle_spawn[ctr]),
				"clicked",
                GTK_SIGNAL_FUNC(check_spawn_choice),
                (gpointer)mother);
	}

	/* -------------------------------------------------------------------- */
	colormap = gtk_widget_get_colormap(spawn_select_form);
	pixmap1 = gdk_pixmap_colormap_create_from_xpm_d(
			NULL, colormap, &bitmap1,
			NULL, arrow_n_xpm);

	mother->main_form.spawn_gtkpixmap[0] = gtk_pixmap_new(pixmap1, bitmap1);
	gtk_widget_show(mother->main_form.spawn_gtkpixmap[0]);

	gtk_container_add(
			GTK_CONTAINER(mother->main_form.toggle_spawn[0]),
			mother->main_form.spawn_gtkpixmap[0]);
	/* -------------------------------------------------------------------- */
	colormap = gtk_widget_get_colormap(spawn_select_form);
	pixmap1 = gdk_pixmap_colormap_create_from_xpm_d(
			NULL, colormap, &bitmap1,
			NULL, arrow_e_xpm);

	mother->main_form.spawn_gtkpixmap[1] = gtk_pixmap_new(pixmap1, bitmap1);
	gtk_widget_show(mother->main_form.spawn_gtkpixmap[1]);

	gtk_container_add(
			GTK_CONTAINER(mother->main_form.toggle_spawn[1]),
			mother->main_form.spawn_gtkpixmap[1]);
	/* -------------------------------------------------------------------- */
	colormap = gtk_widget_get_colormap(spawn_select_form);
	pixmap1 = gdk_pixmap_colormap_create_from_xpm_d(
			NULL, colormap, &bitmap1,
			NULL, arrow_s_xpm);

	mother->main_form.spawn_gtkpixmap[2] = gtk_pixmap_new(pixmap1, bitmap1);
	gtk_widget_show(mother->main_form.spawn_gtkpixmap[2]);

	gtk_container_add(
			GTK_CONTAINER(mother->main_form.toggle_spawn[2]),
			mother->main_form.spawn_gtkpixmap[2]);
	/* -------------------------------------------------------------------- */
	colormap = gtk_widget_get_colormap(spawn_select_form);
	pixmap1 = gdk_pixmap_colormap_create_from_xpm_d(
			NULL, colormap, &bitmap1,
			NULL, arrow_w_xpm);

	mother->main_form.spawn_gtkpixmap[3] = gtk_pixmap_new(pixmap1, bitmap1);
	gtk_widget_show(mother->main_form.spawn_gtkpixmap[3]);

	gtk_container_add(
			GTK_CONTAINER(mother->main_form.toggle_spawn[3]),
			mother->main_form.spawn_gtkpixmap[3]);
	/* -------------------------------------------------------------------- */

	gdk_pixmap_unref(pixmap1);
//	gdk_bitmap_unref(bitmap1);

/*
	gtk_box_pack_start(
			GTK_BOX(main_vbox), ok_button, FALSE, FALSE, 0);
*/
	return spawn_select_form;
}
