#include <gtk/gtk.h>
#include "define.h"
#include "../client_basic_modules/common/module.h"
#include "./art/empty_square.xpm"

void update_design_layout(mother, location)
struct mother_hold *mother;
long location;
{
	node_module_type *module_slider;
	node_layout_ptr layout_slider;
	int module_count;

	GdkColormap *colormap;
	GdkPixmap	*pixmap;
	GdkBitmap	*bitmap;
	GtkStyle	*style;
	GdkGC		*gc;

//	g_print("- adding pixmap edit display\n");

	style = gtk_widget_get_style(mother->server_form.main_window);

	/* Find the location in the description nodes... */
	layout_slider = mother->design_head;
	while(layout_slider) {
		if(layout_slider->location == location) {
			break;
		}
		layout_slider = layout_slider->next_element;
	}

	/* Check for errors */
	if(!layout_slider) {
		g_print("This should not be reached, can't find location in design linklist.\n");
		return;
	}

	/* Create the next pixmap to add to this location. */
	colormap = gtk_widget_get_colormap(mother->server_form.main_window);
	pixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL, colormap,
			&bitmap, NULL, empty_square_xpm);

	/* Create the next pixmap to add to this location. */
/*
    pixmap = gdk_pixmap_create_from_xpm_d(
            mother->server_form.main_window->window, &bitmap,
            &style->bg[GTK_STATE_NORMAL], empty_square_xpm);
*/
	/**
	 * For each node find the related module and add the image to the new
	 * pixmap.
	 */
	while(layout_slider->location == location) {
		/* Find the related module. */
		module_count = 0;
		module_slider = mother->module_head;
		while(module_slider) {
			if(module_count == layout_slider->id) {
				break;
			}
			/* check the next module */
			module_slider = module_slider->next_module;
			module_count++;
		}

		gc = gdk_gc_new(module_slider->info->list_of_large_images[layout_slider->instance]);
	    gdk_gc_set_clip_mask(
				gc,
				module_slider->info->list_of_large_masks[layout_slider->instance]);
		gdk_gc_set_clip_origin(gc, 0, 0);

		/* Add this pixmap to the image that will be added. */
//		g_print("Adding instance %d, of module %d\n",
//				layout_slider->instance, module_count);
		gdk_draw_pixmap(
				pixmap, gc,
				module_slider->info->list_of_large_images[layout_slider->instance],
				0, 0, /* location on the FROM pixmap to start copying from */
				0, 0, /* destination */
				40, 40 /* size of image */);

		/* Move on to next node */
		layout_slider = layout_slider->next_element;
		if(layout_slider == NULL) {
			/* We have run out of elements. */
			break;
		}
	}

	/* Free up resources, should we be doing this??? */
//	  free up the style?
//    gdk_gc_unref(gc);
//    gdk_pixmap_unref(pixmap);
//    gdk_bitmap_unref(bitmap);

	/* Add the image to the toggle button. */
	gtk_pixmap_set(
			GTK_PIXMAP(mother->server_form.tab2.table_of_gtkpixmaps[location]),
			pixmap, bitmap);

//	g_print("- done adding pixmap\n");

	/* ok, no more nodes to add: done updating */
}
