/**
 * Module Network Functions:
 */

#ifndef NETUTIL
#define NETUTIL

#include "../common/server.h"

/**
 * The following simpler to use functions call this function for the
 * actual sending to the user's socket.
 */
int network_write_to_socket(int, char*, int);

/**
 * Used to send characters over the network to a user, to everyone, or
 * to everyone but a single user. The second and third parameters are the
 * character array containing the data to be sent, then the number of
 * characters to send. If there is a fourth parameter that is the id_number
 * of the user to be specified according to the function name.
 */
int network_say_to_user(struct server_info_hold*, char*, int, int);
int network_say_to_all(struct server_info_hold*, char*, int);
int network_say_to_all_but(struct server_info_hold*, char*, int, int);

#endif /* NETUTIL */
