#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../common/user.h"

/**
 * Displays as hex as many characters as indicated by num_chars_to_display
 * which are stored in the char* buffer.
 */
void show_as_hex(int num_chars_to_display, char buffer[]) {
	int ctr, warn = 0;
	unsigned char first, second;

	for(ctr = 0; ctr < num_chars_to_display; ctr ++) {
		first = second = (unsigned char)buffer[ctr];

		/* Display a warning for developers */
		if(first > 127) {
			warn = 1;
		}

		first /= 16;
		second -= (first * 16);

		if(first > 9)
			first = first - 10 + 'A';
		else
			first += '0';

		if(second > 9)
			second = second - 10 + 'A';
		else
			second += '0';

		printf("%c%c ", first, second);
	}
	printf("\n");

	if(warn) {
		printf("There is a char > 127, possibly this will require");
		printf(" special coding in a function.\n");
	}
}

void mystrncpy(unsigned char dest[], unsigned char source[], int length) {
	int ctr;

	for(ctr = 0; ctr < length; ctr ++) {
		dest[ctr] = source[ctr];
	}
}

void remove_chars_from_user_buffer(user_slider, num_of_chars)
struct node_user_type *user_slider;
int num_of_chars;
{
	unsigned char *tmp_string;
	int new_char_count;

	/* Get the number of characters that will be left in buffer after done */
	new_char_count = user_slider->num_of_chars - num_of_chars;

	/* Store the users buffer starting with new characters not used yet */
//	tmp_string = strdup(user_slider->buffer);
	tmp_string = malloc(new_char_count);
	mystrncpy(tmp_string,
			user_slider->buffer + num_of_chars,
			new_char_count);

	/* Now, copy over the characters which are left in the buffer */
	mystrncpy(user_slider->buffer, tmp_string, new_char_count);

	/* Store how many characters are left in the buffer */
	user_slider->num_of_chars = new_char_count;

	free(tmp_string);
}
