/**
 * Network Functions:
 *
 *
 */

#ifndef NETWORK
#define NETWORK

#ifdef WIN32
#include <windows.h>
#include <winsock.h>
#else
#include <netinet/in.h>
#endif /* WIN32 */

#include "../common/server.h"

/**
 * Start listening on the specified port
 */
int network_startup(struct server_info_hold*, int);

/**
 * Called by the server to check for new data in all the sources it
 * is watching.
 */
int network_update_buffers(struct server_info_hold*, char**);

/**
 * The following simpler to use functions call this function for the
 * actual sending to the user's socket.
 */
int network_write_to_socket(int, char*, int);

/**
 * Used to send characters over the network to a user, to everyone, or
 * to everyone but a single user. The second and third parameters are the
 * character array containing the data to be sent, then the number of
 * characters to send. If there is a fourth parameter that is the id_number
 * of the user to be specified according to the function name.
 */
int network_say_to_user(struct server_info_hold*, char*, int, int);
int network_say_to_all(struct server_info_hold*, char*, int);
int network_say_to_all_but_user(struct server_info_hold*, char*, int, int);

#endif /* NETWORK */
