#include <stdio.h>
#include <dlfcn.h>
#include <string.h>
#include "../common/server.h"
#include "../common/user.h"
#include "../common/modutil.h"

int parse_client(server_info)
struct server_info_hold *server_info;
{
	int (*execute_network_command)(
			struct server_info_hold*, struct node_user_type*);
	node_user_ptr user_slider;
	node_module_ptr module_slider;
	int ctr, failed_to_be_handled, done_searching;
	char buff[512];

	/* Loop through all user nodes till we find one with characters */
	user_slider = server_info->user_head;
	while(user_slider) {
		if(user_slider->num_of_chars != 0) {
			break;
		}
		user_slider = user_slider->next_user;
	}

	/* We now have our user, a user will always be found because this */
	/* function is only called when we know a user has sent network data */
	if(!user_slider) {
		printf("after flushing a users buffer the 'has chars' is still\n");
		printf("called... ignoring this call.\n");
		return 1;
	}

/* Let's see if this works to try clearing a users buffer before */
/* continuing... accepting other connections etc... this might lead */
/* to a server being able to be controlled by one user... it has been */
/* up to the modules till this point and as long as this is left out */
/* it still is... but how else to flush a users buffer w/o sucking all */
/* cpu by constantly checking? */
for(;;) {

	/* By default the network command was not handled, no module was able */
	/* to handle it... */
	failed_to_be_handled = 1;

	/* Loop through the modules looking for one that handles this */
	/* network command and then call its function */
	done_searching = FALSE;
	printf("*** Looking for net commands:\n");
	module_slider = server_info->module_head;
	while(module_slider) {
		printf("\t'%s':", module_slider->name);

		/* Does this module handle network commands we can use? */
		for(ctr = 0;
			ctr < module_slider->info->num_of_network_commands;
			ctr ++) {
			printf(" %d", module_slider->info->list_of_network_commands[ctr]);
			if(module_slider->info->list_of_network_commands[ctr]
					== user_slider->buffer[0]) {
				printf("<-FOUND!\n");

				/* ok, this module can handle this network command */
				strcpy(buff, "network_command_handler");
				printf("-*- calling '%s'\n", buff);

				execute_network_command = dlsym(module_slider->handle,
						buff);
				execute_network_command(server_info,
						user_slider);

				/* call the appropriate function */
				failed_to_be_handled = 0;

				/* make it so we exit the loop next attempt */
				done_searching = TRUE;
				break;
			}
		}
		printf("\n");

		if(done_searching == TRUE) {
			break;
		}

		module_slider = module_slider->next_module;
	}

	/* The user sent a network command that no module could handle */
	if(failed_to_be_handled) {
		printf("\n~= User's network command was unable to be handled\n");
		printf("~= ... clearing their buffer as opposed to killing them\n");
		user_slider->num_of_chars = 0;
	}

/**
 * Exit from our forever loop. This technique will only work if the client
 * ALWAYS sends complete commands to the server. Otherwise partial commands
 * will be attempted by the modules and when it tries to read from the
 * buffer there won't be enough information.  We were already relying on
 * this type of action by the client.
 */
if(user_slider->num_of_chars == 0) {
	break;
}

}

	return 0;
}
