#include <stdio.h>
#include <stdlib.h>
#include "sortlist.h"
#include "../common/module.h"
#include "../common/define.h"

/* Add this new module node to our sorted linked list */
int link_sort_next_node(
		sort_list_head, new_module_node, priority_value, curr_timing)
node_sort_type **sort_list_head;
node_module_ptr new_module_node;
unsigned int priority_value;
unsigned int curr_timing;
{
	node_sort_ptr sort_slider;
	node_sort_ptr new_sort_node;

	/* We already know there will be a new sort node */
	new_sort_node = (node_sort_ptr) calloc (1, sizeof(node_sort_type));
	new_sort_node->priority_value = priority_value;
	new_sort_node->module = new_module_node;
	new_sort_node->next_sort = NULL;

	if((*sort_list_head) == NULL) {
		*sort_list_head = new_sort_node;
	}
	/* Maybe this node's priority is lower than the head node */
	else if((*sort_list_head)->priority_value > priority_value) {
		new_sort_node->next_sort = (*sort_list_head);
		(*sort_list_head) = new_sort_node;
	}
	/* Now it will either be an insert or we'll loop till end of link list */
	else {
		sort_slider = (*sort_list_head);

		while(sort_slider->next_sort) {
			if(sort_slider->next_sort->priority_value > priority_value) {
				new_sort_node->next_sort = sort_slider->next_sort;
				sort_slider->next_sort = new_sort_node;
				break;
			}
			sort_slider = sort_slider->next_sort;
		}
		if(!sort_slider->next_sort) {
			/* Attach to end of list */
			sort_slider->next_sort = new_sort_node;
		}
	}

	return 0;
}

/* Clear out the link list we created for priority sorting purposes */
int link_clear_list(sort_list_head)
node_sort_ptr sort_list_head;
{
	node_sort_ptr kill_slider;
	node_sort_ptr next_slider;

	kill_slider = sort_list_head;
	while(kill_slider) {
		next_slider = kill_slider->next_sort;
		free(kill_slider);

		kill_slider = next_slider;
	};

	return 0;
}
