#include <stdio.h>
#include "../common/loadall.h"
#include "start_functions.h"
#include "getmodid.h"

void case_admin_start_game(server_info)
struct server_info_hold *server_info;
{
	char tosend[6];


	/* Send network command indicating the game is starting. */

	// **_ Use this method instead???? _**

	/**
	 * S_ACTION 111 222 333 444 555
	 *    111 is the module which is sending this message
	 *    222 is the instance of the module (perhaps this doesn't matter, will
	 *        be zero in this case but can be ignored
	 *    333 is the module which is the target of this message
	 *    444 is the instance of the module (perhaps this doesn't matter, will
	 *        be zero in this case but can be ignored
	 *    555 is the message which will be translated by a client-side module
	 */
//	network_say_to_all(server_info, tosend, length_of_emote + 3);

	tosend[0] = S_STARTING_LAYOUT_DESCRIPTION;
	network_say_to_all(server_info, tosend, 1);

	printf("[ADMIN] Action: Initializing all games by calling 'init_start_game'.\n");

	/* Call the start function in each module which is an element */
	call_start_functions(server_info);

	tosend[0] = S_ENDING_LAYOUT_DESCRIPTION;
	network_say_to_all(server_info, tosend, 1);

	tosend[0] = S_GAME_IS_NOW_STARTING;
	network_say_to_all(server_info, tosend, 1);

	/**
	 * Tell robot client node to display the initial archive location.
	 */
	tosend[0] = S_ACTION;
	tosend[1] = get_module_id_from_name(server_info, "s_robot");
	tosend[2] = 0;
	tosend[3] = tosend[1];
	tosend[4] = 0;
	tosend[5] = 1;
	network_say_to_all(server_info, tosend, 6);

	/**
	 * Set server variables needed to make the game run
	 */

	/* this will become true after all robots have sent in their initial
	 * direction
	 */
	server_info->set_game_in_progress = FALSE;

	server_info->number_of_timing_sessions = NUM_OF_ROBOT_RACE_TIMING_SESSIONS;

}
