/**
 * Will call a function in the 'robot' module that will, locally to the robot
 * module, add a robot node that will be used later for game play. If the user
 * decides not to participate in this game their robot node will be removed
 * when the game starts.
 *
 * Module Dependencies: robot
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dlfcn.h>
#include "../common/loadall.h"

void add_robot_node(server_info, user_node)
struct server_info_hold *server_info;
struct node_user_type *user_node;
{
	int (*add_new_node)(struct server_info_hold*, struct node_user_type*);
	struct node_module_type* module_slider;

	/* Find the robot module we need */
	/* Find the module node in the linked list */
	module_slider = server_info->module_head;
	while(module_slider) {
		if(!strcmp(module_slider->name, "s_robot")) {
			break;
		}

		module_slider = module_slider->next_module;
	}

	/* Call the function to add the new robot node */
	add_new_node = dlsym(module_slider->handle,
			"add_new_robot_node");
	add_new_node(server_info, user_node);
}
