/**
 * User wishes to send an action/emote to the main channel.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../common/loadall.h"

/* Implements server response to C_EMOTE */
/* ## - length of the emote including null */
/* SS - the string of the emote */
void case_emote(server_info, user_slider)
struct server_info_hold *server_info;
struct node_user_type *user_slider;
{
	int length_of_emote;
	char buff[512], tosend[512];

	length_of_emote = user_slider->buffer[1];
	strncpy(buff, user_slider->buffer+2, length_of_emote);

	/* Send this emote to everyone including the person who sent it */
	/* This is actually for testing purposes and a talk emote should */
	/* not actually be sent back to the same person who sent it, as they */
	/* already know the information and need not waste bandwidth */
	tosend[0] = S_EMOTE;
	tosend[1] = user_slider->id_number;
	tosend[2] = length_of_emote;
	strncpy(tosend+3, buff, length_of_emote);

/*	network_say_to_all_but(server_info, tosend, length_of_emote + 3,
			user_slider->id_number);
*/
	network_say_to_all(server_info, tosend, length_of_emote + 3);

	/* Remove all the chars involved with this protocol */
	remove_chars_from_user_buffer(user_slider, length_of_emote + 2);
}
