/**
 *
 * Author: Travis W. Loyd
 */

#include <string.h>
#include "../common/loadall.h"

/**
 * This description is from rr5 and may need to be updated, copy/pasted for
 * convenience for now...
 *
 * The number associated with each element module is simply the number in order
 * of the link list of module nodes... if a module is loaded or unloaded this
 * can change the number associated with the element node. The only solution is
 * to load all modules before the game begins or to only add modules available.
 * Element modules added later on will not be accessible less this information
 * is sent again. This can be changed later on to make loading & unloading
 * element modules more convinient.
 */
int send_module_list(server_info, user_node)
struct server_info_hold *server_info;
struct node_user_type *user_node;
{
	int ptr, count;
	char tosend[512];
	struct node_module_type *module_slider;

	tosend[0] = S_ELEMENT_LIST;

	/* Add each module one by one */
	ptr = 2;
	count = 0;
	module_slider = server_info->module_head;
	while(module_slider) {
		/* Add the element name to the list */
		tosend[ptr] = count ++;
		ptr ++;
		tosend[ptr] = strlen(module_slider->name) + 1;
		ptr ++;
		strcpy(tosend + ptr, module_slider->name);
		ptr += tosend[ptr-1] - 1;

		/* Skip to after the null end to the string nick */
		ptr ++;

		/* Move to next module */
		module_slider = module_slider->next_module;
	}

	/* Add the number of elements that are listed. */
	tosend[1] = count;

//	show_as_hex(ptr, tosend);
	network_say_to_user(server_info, tosend, ptr, user_node->id_number);

	return 1;
}
