/**
 * User wishes to send a message to the main channel.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../common/loadall.h"

/* Implements server response to C_TALK */
/* ## - length of the message including null */
/* SS - the string of the message */
void case_talk(server_info, user_slider)
struct server_info_hold *server_info;
struct node_user_type *user_slider;
{
	int length_of_message;
	char buff[512], tosend[512];

	length_of_message = user_slider->buffer[1];
	strncpy(buff, user_slider->buffer+2, length_of_message);

	/* Send this message to everyone including the person who sent it */
	/* This is actually for testing purposes and a talk message should */
	/* not actually be sent back to the same person who sent it, as they */
	/* already know the information and need not waste bandwidth */
	tosend[0] = S_TALK;
	tosend[1] = user_slider->id_number;
	tosend[2] = length_of_message;
	strncpy(tosend+3, buff, length_of_message);

/*	network_say_to_all_but(server_info, tosend, length_of_message + 3,
			user_slider->id_number);
*/
	network_say_to_all(server_info, tosend, length_of_message + 3);

	/* Remove all the chars involved with this protocol */
	remove_chars_from_user_buffer(user_slider, length_of_message + 2);
}
