/**
 * This is called if a user has connected to the server and just sent in
 * his/her nick name. It sends the list of 'userptr' number values that will
 * be associated with a user's nick.
 *
 * Author: Travis W. Loyd
 */

#include <stdlib.h>
#include <string.h>
#include "../common/loadall.h"

/* Generates a user listing and sends it to client, this only happens */
/* once per client right after the client sends their initial nickname */
void send_userlist(server_info, new_user_node)
struct server_info_hold *server_info;
struct node_user_type *new_user_node;
{
	int ptr;
	char tosend[512];
	struct node_user_type *user_slider;

	tosend[0] = S_USER_LIST;
	tosend[1] = server_info->number_of_users_connected;

	/* Add each user one by one */
	user_slider = server_info->user_head;
	ptr = 2;
	while(user_slider) {
		tosend[ptr] = user_slider->id_number;
		ptr ++;
		tosend[ptr] = strlen(user_slider->nick) + 1;
		ptr ++;
		strcpy(tosend + ptr, user_slider->nick);
		ptr += tosend[ptr-1] - 1;

		/* Skip to after the null end to the string nick */
		ptr ++;

		user_slider = user_slider->next_user;
	}

/*	network_say_to_all_but(server_info, tosend, length_of_message + 3,
			user_slider->id_number);
*/
	show_as_hex(ptr, tosend);
	network_say_to_user(server_info, tosend, ptr, new_user_node->id_number);
}
