/**
 * User has sent a message to only one other user, only the single destined
 * user will recieve the message.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../common/loadall.h"

/* Implements server response to C_WHISPER */
/* ## - length of the whisper including null */
/* SS - the string of the whisper */
void case_whisper(server_info, user_slider)
struct server_info_hold *server_info;
struct node_user_type *user_slider;
{
	int length_of_whisper;
	int recipient_id_number;
	char buff[512], tosend[512];

	recipient_id_number = user_slider->buffer[1];
	length_of_whisper = user_slider->buffer[2];
	strncpy(buff, user_slider->buffer+3, length_of_whisper);

	/* Build whisper network data string to send to recipient client */
	tosend[0] = S_WHISPER;
	tosend[1] = user_slider->id_number;
	tosend[2] = length_of_whisper;
	strncpy(tosend+3, buff, length_of_whisper);

show_as_hex(length_of_whisper + 3, tosend);

	/* Send whisper to the recipient only */
	network_say_to_user(server_info, tosend, length_of_whisper + 3,
			recipient_id_number);

	/* Remove all the chars involved with this protocol */
	remove_chars_from_user_buffer(user_slider, length_of_whisper + 3);
}
