#include <stdio.h>
#include <dlfcn.h>

#include "../common/loadall.h"
#include "s_basic_checkpoint.h"

void tag_checkpoints(server_info, checkpoint_head, last_checkpoint)
struct server_info_hold *server_info;
struct node_checkpoint_type *checkpoint_head;
int last_checkpoint;
{
	int (*_tag_checkpoint)(long, long);
	int (*_is_here)(long, long, int);
	long (*_num_of_instances)(void);
	long ctr;
	long count;
	struct node_checkpoint_type *checkpoint_slider;
	struct node_module_type *module_slider;
	int checkpoint_ref_id;
	char tosend[8];
	int result;

	printf("updating archive locations via checkpoints now\n");

    /**
     * find reference id numbers for network communications
     */
    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_basic_checkpoint")) {
            checkpoint_ref_id = module_slider->id;
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[CHECKPOINT] this point should never be reached 1\n");
        return;
    }                                                                          

    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_robot")) {
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[CHECKPOINT] this point should never be reached 2\n");
		return;
	}

	_tag_checkpoint = dlsym(
			module_slider->handle,
			"tag_checkpoint");

	_num_of_instances = dlsym(
			module_slider->handle,
			"num_of_instances");

	count = _num_of_instances();

	/* is this moveable module type at this location? */
	for(ctr = 0; ctr < count; ctr ++) {
		/* loop through all the checkpoints */
		checkpoint_slider = checkpoint_head;
		while(checkpoint_slider) {
			/* is this checkpoint at the location of the object */
			_is_here = dlsym(module_slider->handle, "is_here");

			/* if so set the robots archive location */
			if(_is_here(checkpoint_slider->x, checkpoint_slider->y, ctr)) {
printf("[BASIC_CHECKPOINT] FOUND @ (%ld,%ld): setting archive location %ld\n",
		checkpoint_slider->x, checkpoint_slider->y, ctr);

				result = _tag_checkpoint(
						ctr, checkpoint_slider->type);

				/* if the checkpoint was tagged send the network chat */
				if(result) {
					tosend[0] = S_ACTION;
					tosend[1] = checkpoint_ref_id;
					tosend[2] = -1;
					tosend[3] = module_slider->id;
					tosend[4] = ctr;
					tosend[5] = 0;
					tosend[6] = checkpoint_slider->type;

					network_say_to_all(server_info, tosend, 7);

					if(checkpoint_slider->type+1 == last_checkpoint) {
						last_checkpoint = -1;
printf("LAST CHECKPOINT TAGGED\n");
						server_info->set_game_in_progress = 2;

						tosend[0] = S_ACTION;
						tosend[1] = checkpoint_ref_id;
						tosend[2] = -1;
						tosend[3] = module_slider->id;
						tosend[4] = ctr;
						tosend[5] = 1;
						network_say_to_all(server_info, tosend, 6);

						/* might as well return, this game is over */
						return;
					}
				}
			}
//			else {
//				printf("no checkpoint at %ld,%ld: %ld\n",
//						checkpoint_slider->x, checkpoint_slider->y, ctr);
//			}

			checkpoint_slider = checkpoint_slider->next_checkpoint;
		}
	}
}
