/**
 * Creates and adds new checkpoint node to the link list of checkpoints used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"
#include "s_basic_checkpoint.h"

/**
 */
int add_checkpoint_node(server_info, checkpoint_head, user_node)
struct server_info_hold *server_info;
struct node_checkpoint_type **checkpoint_head;
struct node_user_type *user_node;
{
	node_checkpoint_ptr checkpoint_slider;
	node_checkpoint_ptr new_checkpoint_ptr;

	printf("// Adding new checkpoint node\n");

	/* Allocate a new checkpoint node for this new user */
	new_checkpoint_ptr = (node_checkpoint_ptr) calloc (1, sizeof(node_checkpoint_type));

	/* Fill in the new information about the checkpoint */
	new_checkpoint_ptr->x = (long)(user_node->buffer[0] * 250 + user_node->buffer[1]);
	new_checkpoint_ptr->y = (long)(user_node->buffer[2] * 250 + user_node->buffer[3]);
	new_checkpoint_ptr->type = user_node->buffer[4];
	/* The next node is always NULL */
	new_checkpoint_ptr->next_checkpoint = NULL;

	/* Move to the end of the node list & attach */
	checkpoint_slider = (*checkpoint_head);
	if(checkpoint_slider == NULL) {
		(*checkpoint_head) = new_checkpoint_ptr;
	}
	else if(checkpoint_slider->next_checkpoint == NULL) {
		checkpoint_slider->next_checkpoint = new_checkpoint_ptr;
	}
	else {
		do {
			checkpoint_slider = checkpoint_slider->next_checkpoint;
		} while(checkpoint_slider->next_checkpoint != NULL);
		checkpoint_slider->next_checkpoint = new_checkpoint_ptr;
	}

	printf("// done.\n");

/*
	printf("Listing the checkpoint link-list\n");
	checkpoint_slider = (*checkpoint_head);
	while(checkpoint_slider) {
		printf("%ld, %ld, %d\n",
				checkpoint_slider->x,
				checkpoint_slider->y,
				checkpoint_slider->type);
		checkpoint_slider = checkpoint_slider->next_checkpoint;
	}
	printf("done.\n");
*/
	return 1;
}
