/**
 * Creates and adds new crusher node to the link list of crushers used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"
#include "s_basic_crusher.h"

/**
 */
int add_crusher_node(server_info, crusher_head, user_node)
struct server_info_hold *server_info;
struct node_crusher_type **crusher_head;
struct node_user_type *user_node;
{
	node_crusher_ptr crusher_slider;
	node_crusher_ptr new_crusher_ptr;

	printf("// Adding new crusher node\n");

	/* Allocate a new crusher node for this new user */
	new_crusher_ptr = (node_crusher_ptr) calloc (1, sizeof(node_crusher_type));

	/* Fill in the new information about the crusher */
	new_crusher_ptr->x = (long)(user_node->buffer[0] * 250 + user_node->buffer[1]);
	new_crusher_ptr->y = (long)(user_node->buffer[2] * 250 + user_node->buffer[3]);
	new_crusher_ptr->type = user_node->buffer[4];
	/* The next node is always NULL */
	new_crusher_ptr->next_crusher = NULL;

	/* Move to the end of the node list & attach */
	crusher_slider = (*crusher_head);
	if(crusher_slider == NULL) {
		(*crusher_head) = new_crusher_ptr;
	}
	else if(crusher_slider->next_crusher == NULL) {
		crusher_slider->next_crusher = new_crusher_ptr;
	}
	else {
		do {
			crusher_slider = crusher_slider->next_crusher;
		} while(crusher_slider->next_crusher != NULL);
		crusher_slider->next_crusher = new_crusher_ptr;
	}

	printf("// done.\n");

/*
	printf("Listing the crusher link-list\n");
	crusher_slider = (*crusher_head);
	while(crusher_slider) {
		printf("%ld, %ld, %d\n",
				crusher_slider->x,
				crusher_slider->y,
				crusher_slider->type);
		crusher_slider = crusher_slider->next_crusher;
	}
	printf("done.\n");
*/
	return 1;
}
