/**
 * Creates and adds new gear node to the link list of gears used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"
#include "s_basic_gear.h"

/**
 */
int add_gear_node(server_info, gear_head, user_node)
struct server_info_hold *server_info;
struct node_gear_type **gear_head;
struct node_user_type *user_node;
{
	node_gear_ptr gear_slider;
	node_gear_ptr new_gear_ptr;

	printf("// Adding new gear node\n");

	/* Allocate a new gear node for this new user */
	new_gear_ptr = (node_gear_ptr) calloc (1, sizeof(node_gear_type));

	/* Fill in the new information about the gear */
	new_gear_ptr->x = (long)(user_node->buffer[0] * 250 + user_node->buffer[1]);
	new_gear_ptr->y = (long)(user_node->buffer[2] * 250 + user_node->buffer[3]);
	new_gear_ptr->type = user_node->buffer[4];
	/* The next node is always NULL */
	new_gear_ptr->next_gear = NULL;

	/* Move to the end of the node list & attach */
	gear_slider = (*gear_head);
	if(gear_slider == NULL) {
		(*gear_head) = new_gear_ptr;
	}
	else if(gear_slider->next_gear == NULL) {
		gear_slider->next_gear = new_gear_ptr;
	}
	else {
		do {
			gear_slider = gear_slider->next_gear;
		} while(gear_slider->next_gear != NULL);
		gear_slider->next_gear = new_gear_ptr;
	}

	printf("// done.\n");

/*
	printf("Listing the gear link-list\n");
	gear_slider = (*gear_head);
	while(gear_slider) {
		printf("%ld, %ld, %d\n",
				gear_slider->x,
				gear_slider->y,
				gear_slider->type);
		gear_slider = gear_slider->next_gear;
	}
	printf("done.\n");
*/
	return 1;
}
