#include <stdio.h>
#include <dlfcn.h>

#include "../common/loadall.h"
#include "s_basic_laser.h"

void spin_lasers(server_info, laser_head)
struct server_info_hold *server_info;
struct node_laser_type *laser_head;
{
	int (*move_with_check)(struct server_info_hold*, int, long);
	int (*is_here)(long, long, int);
	long (*num_of_instances)(void);
	long ctr;
	long count;
	int num_of_styles;
	int style;
	struct node_laser_type *laser_slider;
	struct node_module_type *module_slider;
	int result;
	int laser_ref_id;
	char tosend[7];

//	printf("spining lasers now\n");

    /**
     * find reference id numbers for network communications
     */
    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_basic_laser")) {
            laser_ref_id = module_slider->id;
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[LASER] this point should never be reached\n");
        return;
    }                                                                          

	/* find next moveable object */
	module_slider = server_info->module_head;
	while(module_slider) {
		num_of_styles = module_slider->info->num_of_styles;
		for(style = 0; style < num_of_styles; style++) {
			if(!strcmp(module_slider->info->list_of_styles[style], "move")) {
				/* next moveable object found */

				/* loop through the instances of this module */
				num_of_instances = dlsym(
						module_slider->handle, "num_of_instances");

				count = num_of_instances();

				/* is this moveable module type at this location? */
				for(ctr = 0; ctr < count; ctr ++) {
					/* loop through all the lasers */
					laser_slider = laser_head;
					while(laser_slider) {
						/* is this laser at the location of the object */
						is_here = dlsym(module_slider->handle, "is_here");

						/* if so move it appropriately */
						if(is_here(laser_slider->x, laser_slider->y, ctr)) {
printf("[BASIC_LASER] FOUND @ (%ld,%ld): moving instance %ld\n",
		laser_slider->x, laser_slider->y, ctr);
							move_with_check = dlsym(
									module_slider->handle,
									"move_with_check");
							/* add one so it represents one of the */
							/* movements in the movement.h file */
							result = move_with_check(
									server_info,
									1+laser_slider->type,
									ctr);

							tosend[0] = S_ACTION;
							tosend[1] = laser_ref_id;
							tosend[2] = -1;
							tosend[3] = module_slider->id;
							tosend[4] = ctr;
							tosend[5] = 0;
							if(result != -1) {
								tosend[6] = 1+laser_slider->type + 10;
							}
							else {
								tosend[6] = 1+laser_slider->type;
							}
							network_say_to_all(server_info, tosend, 7);
						}
//						else {
//							printf("no laser at %ld,%ld: %ld\n",
//									laser_slider->x, laser_slider->y, ctr);
//						}

						laser_slider = laser_slider->next_laser;
					}
				}
			}
		}

		module_slider = module_slider->next_module;
	}
}
