/**
 * Creates and adds new laser node to the link list of lasers used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"
#include "s_basic_laser.h"

/**
 */
int add_laser_node(server_info, laser_head, user_node)
struct server_info_hold *server_info;
struct node_laser_type **laser_head;
struct node_user_type *user_node;
{
	node_laser_ptr laser_slider;
	node_laser_ptr new_laser_ptr;

	printf("// Adding new laser node\n");

	/* Allocate a new laser node for this new user */
	new_laser_ptr = (node_laser_ptr) calloc (1, sizeof(node_laser_type));

	/* Fill in the new information about the laser */
	new_laser_ptr->x = (long)(user_node->buffer[0] * 250 + user_node->buffer[1]);
	new_laser_ptr->y = (long)(user_node->buffer[2] * 250 + user_node->buffer[3]);
	new_laser_ptr->type = user_node->buffer[4];
	/* The next node is always NULL */
	new_laser_ptr->next_laser = NULL;

	/* Move to the end of the node list & attach */
	laser_slider = (*laser_head);
	if(laser_slider == NULL) {
		(*laser_head) = new_laser_ptr;
	}
	else if(laser_slider->next_laser == NULL) {
		laser_slider->next_laser = new_laser_ptr;
	}
	else {
		do {
			laser_slider = laser_slider->next_laser;
		} while(laser_slider->next_laser != NULL);
		laser_slider->next_laser = new_laser_ptr;
	}

	printf("// done.\n");

/*
	printf("Listing the laser link-list\n");
	laser_slider = (*laser_head);
	while(laser_slider) {
		printf("%ld, %ld, %d\n",
				laser_slider->x,
				laser_slider->y,
				laser_slider->type);
		laser_slider = laser_slider->next_laser;
	}
	printf("done.\n");
*/
	return 1;
}
