#include <stdio.h>
#include <dlfcn.h>

#include "../common/loadall.h"
#include "s_basic_pit.h"

void action_pits(server_info, pit_head)
struct server_info_hold *server_info;
struct node_pit_type *pit_head;
{
	int (*_destroy)(long, long, long);
	int (*_is_here)(long, long, int);
	long (*num_of_instances)(void);
	long ctr;
	long count;
	int num_of_styles;
	int style;
	struct node_pit_type *pit_slider;
	struct node_module_type *module_slider;
	int result;
	int pit_ref_id;
	char tosend[7];

//	printf("activating pits now\n");

    /**
     * find reference id numbers for network communications
     */
    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_basic_pit")) {
            pit_ref_id = module_slider->id;
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[PIT] this point should never be reached\n");
        return;
    }                                                                          

	/* find next moveable object */
	module_slider = server_info->module_head;
	while(module_slider) {
		num_of_styles = module_slider->info->num_of_styles;
		for(style = 0; style < num_of_styles; style++) {
			if(!strcmp(module_slider->info->list_of_styles[style], "damage")) {
				/* next moveable object found */

				/* loop through the instances of this module */
				num_of_instances = dlsym(
						module_slider->handle, "num_of_instances");

				count = num_of_instances();

				/* is this moveable module type at this location? */
				for(ctr = 0; ctr < count; ctr ++) {
					/* loop through all the pits */
					pit_slider = pit_head;
					while(pit_slider) {
						/* is this pit at the location of the object */
						_is_here = dlsym(module_slider->handle, "is_here");

						/* if so move it appropriately */
						if(_is_here(pit_slider->x, pit_slider->y, ctr)) {
printf("[BASIC_PIT] FOUND @ (%ld,%ld): destroying instance %ld\n",
		pit_slider->x, pit_slider->y, ctr);
							/* destroy this thing! */
							_destroy = dlsym(
									module_slider->handle,
									"destroy");

							result = _destroy(
									pit_slider->x,
									pit_slider->y,
									ctr);

							tosend[0] = S_ACTION;
							tosend[1] = pit_ref_id;
							tosend[2] = -1;
							tosend[3] = module_slider->id;
							tosend[4] = ctr;
							tosend[5] = 0;
							tosend[6] = result;
							network_say_to_all(server_info, tosend, 7);
						}

						pit_slider = pit_slider->next_pit;
					}
				}
			}
		}

		module_slider = module_slider->next_module;
	}
}
