/**
 * Creates and adds new pit node to the link list of pits used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"
#include "s_basic_pit.h"

/**
 */
int add_pit_node(server_info, pit_head, user_node)
struct server_info_hold *server_info;
struct node_pit_type **pit_head;
struct node_user_type *user_node;
{
	node_pit_ptr pit_slider;
	node_pit_ptr new_pit_ptr;

	printf("// Adding new pit node\n");

	/* Allocate a new pit node for this new user */
	new_pit_ptr = (node_pit_ptr) calloc (1, sizeof(node_pit_type));

	/* Fill in the new information about the pit */
	new_pit_ptr->x = (long)(user_node->buffer[0] * 250 + user_node->buffer[1]);
	new_pit_ptr->y = (long)(user_node->buffer[2] * 250 + user_node->buffer[3]);
	new_pit_ptr->type = user_node->buffer[4];
	/* The next node is always NULL */
	new_pit_ptr->next_pit = NULL;

	/* Move to the end of the node list & attach */
	pit_slider = (*pit_head);
	if(pit_slider == NULL) {
		(*pit_head) = new_pit_ptr;
	}
	else if(pit_slider->next_pit == NULL) {
		pit_slider->next_pit = new_pit_ptr;
	}
	else {
		do {
			pit_slider = pit_slider->next_pit;
		} while(pit_slider->next_pit != NULL);
		pit_slider->next_pit = new_pit_ptr;
	}

	printf("// done.\n");
/*
	printf("Listing the pit link-list\n");
	pit_slider = (*pit_head);
	while(pit_slider) {
		printf("%ld, %ld, %d\n",
				pit_slider->x,
				pit_slider->y,
				pit_slider->type);
		pit_slider = pit_slider->next_pit;
	}
	printf("done.\n");
*/
	return 1;
}
