/**
 * Creates and adds new pusher node to the link list of pushers used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"
#include "s_basic_pusher.h"

/**
 */
int add_pusher_node(server_info, pusher_head, user_node)
struct server_info_hold *server_info;
struct node_pusher_type **pusher_head;
struct node_user_type *user_node;
{
	node_pusher_ptr pusher_slider;
	node_pusher_ptr new_pusher_ptr;

	printf("// Adding new pusher node\n");

	/* Allocate a new pusher node for this new user */
	new_pusher_ptr = (node_pusher_ptr) calloc (1, sizeof(node_pusher_type));

	/* Fill in the new information about the pusher */
	new_pusher_ptr->x = (long)(user_node->buffer[0] * 250 + user_node->buffer[1]);
	new_pusher_ptr->y = (long)(user_node->buffer[2] * 250 + user_node->buffer[3]);
	new_pusher_ptr->type = user_node->buffer[4];
	/* The next node is always NULL */
	new_pusher_ptr->next_pusher = NULL;

	/* Move to the end of the node list & attach */
	pusher_slider = (*pusher_head);
	if(pusher_slider == NULL) {
		(*pusher_head) = new_pusher_ptr;
	}
	else if(pusher_slider->next_pusher == NULL) {
		pusher_slider->next_pusher = new_pusher_ptr;
	}
	else {
		do {
			pusher_slider = pusher_slider->next_pusher;
		} while(pusher_slider->next_pusher != NULL);
		pusher_slider->next_pusher = new_pusher_ptr;
	}

	printf("// done.\n");

/*
	printf("Listing the pusher link-list\n");
	pusher_slider = (*pusher_head);
	while(pusher_slider) {
		printf("%ld, %ld, %d\n",
				pusher_slider->x,
				pusher_slider->y,
				pusher_slider->type);
		pusher_slider = pusher_slider->next_pusher;
	}
	printf("done.\n");
*/
	return 1;
}
