#include <stdio.h>
#include <dlfcn.h>

#include "../common/loadall.h"
#include "s_basic_repair.h"

void action_repairs_update_archive_location(server_info, repair_head)
struct server_info_hold *server_info;
struct node_repair_type *repair_head;
{
	void (*_set_archive_location)(long, long, long);
	int (*_is_here)(long, long, int);
	long (*_num_of_instances)(void);
	long ctr;
	long count;
	struct node_repair_type *repair_slider;
	struct node_module_type *module_slider;
	int repair_ref_id;
	char tosend[8];

	printf("updating archive locations via repairs now\n");

    /**
     * find reference id numbers for network communications
     */
    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_basic_repair")) {
            repair_ref_id = module_slider->id;
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[REPAIR] this point should never be reached 1\n");
        return;
    }                                                                          

    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_robot")) {
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[REPAIR] this point should never be reached 2\n");
		return;
	}

	_set_archive_location = dlsym(
			module_slider->handle,
			"set_archive_location");
	_num_of_instances = dlsym(
			module_slider->handle, "num_of_instances");

	count = _num_of_instances();

	/* is this moveable module type at this location? */
	for(ctr = 0; ctr < count; ctr ++) {
		/* loop through all the repairs */
		repair_slider = repair_head;
		while(repair_slider) {
			/* is this repair at the location of the object */
			_is_here = dlsym(module_slider->handle, "is_here");

			/* if so set the robots archive location */
			if(_is_here(repair_slider->x, repair_slider->y, ctr)) {
printf("[BASIC_REPAIR] FOUND @ (%ld,%ld): setting archive location %ld\n",
		repair_slider->x, repair_slider->y, ctr);

				_set_archive_location(
						ctr, repair_slider->x, repair_slider->y);

				tosend[0] = S_ACTION;
				tosend[1] = repair_ref_id;
				tosend[2] = -1;
				tosend[3] = module_slider->id;
				tosend[4] = ctr;
				tosend[5] = 0;
				tosend[6] = repair_slider->x;
				tosend[7] = repair_slider->y;

				network_say_to_all(server_info, tosend, 8);
			}
//			else {
//				printf("no repair at %ld,%ld: %ld\n",
//						repair_slider->x, repair_slider->y, ctr);
//			}

			repair_slider = repair_slider->next_repair;
		}
	}
}

void action_repairs_heal(server_info, repair_head)
struct server_info_hold *server_info;
struct node_repair_type *repair_head;
{
	void (*_set_archive_location)(long, long, long);
	int (*_is_here)(long, long, int);
	long (*_num_of_instances)(void);
	long ctr;
	long count;
	struct node_repair_type *repair_slider;
	struct node_module_type *module_slider;
	int repair_ref_id;
//	char tosend[8];

	printf("healing via repairs now\n");
return;

    /**
     * find reference id numbers for network communications
     */
    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_basic_repair")) {
            repair_ref_id = module_slider->id;
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[REPAIR] this point should never be reached 1\n");
        return;
    }                                                                          

    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_robot")) {
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[REPAIR] this point should never be reached 2\n");
		return;
	}

	_set_archive_location = dlsym(
			module_slider->handle,
			"set_archive_location");
	_num_of_instances = dlsym(
			module_slider->handle, "num_of_instances");

	count = _num_of_instances();

	/* is this moveable module type at this location? */
	for(ctr = 0; ctr < count; ctr ++) {
		/* loop through all the repairs */
		repair_slider = repair_head;
		while(repair_slider) {
			/* is this repair at the location of the object */
			_is_here = dlsym(module_slider->handle, "is_here");

			/* if so set the robots archive location */
			if(_is_here(repair_slider->x, repair_slider->y, ctr)) {
printf("[BASIC_REPAIR] FOUND @ (%ld,%ld): setting archive location %ld\n",
		repair_slider->x, repair_slider->y, ctr);
printf("Implement Healing and Dealing Option Cards Here.\n");
/*
				_set_archive_location(
						ctr, repair_slider->x, repair_slider->y);

				tosend[0] = S_ACTION;
				tosend[1] = repair_ref_id;
				tosend[2] = -1;
				tosend[3] = module_slider->id;
				tosend[4] = ctr;
				tosend[5] = 0;
				tosend[6] = repair_slider->x;
				tosend[7] = repair_slider->y;

				network_say_to_all(server_info, tosend, 8);
*/
			}
//			else {
//				printf("no repair at %ld,%ld: %ld\n",
//						repair_slider->x, repair_slider->y, ctr);
//			}

			repair_slider = repair_slider->next_repair;
		}
	}
}
