/**
 * Creates and adds new repair node to the link list of repairs used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"
#include "s_basic_repair.h"

/**
 */
int add_repair_node(server_info, repair_head, user_node)
struct server_info_hold *server_info;
struct node_repair_type **repair_head;
struct node_user_type *user_node;
{
	node_repair_ptr repair_slider;
	node_repair_ptr new_repair_ptr;

	printf("// Adding new repair node\n");

	/* Allocate a new repair node for this new user */
	new_repair_ptr = (node_repair_ptr) calloc (1, sizeof(node_repair_type));

	/* Fill in the new information about the repair */
	new_repair_ptr->x = (long)(user_node->buffer[0] * 250 + user_node->buffer[1]);
	new_repair_ptr->y = (long)(user_node->buffer[2] * 250 + user_node->buffer[3]);
	new_repair_ptr->type = user_node->buffer[4];
	/* The next node is always NULL */
	new_repair_ptr->next_repair = NULL;

	/* Move to the end of the node list & attach */
	repair_slider = (*repair_head);
	if(repair_slider == NULL) {
		(*repair_head) = new_repair_ptr;
	}
	else if(repair_slider->next_repair == NULL) {
		repair_slider->next_repair = new_repair_ptr;
	}
	else {
		do {
			repair_slider = repair_slider->next_repair;
		} while(repair_slider->next_repair != NULL);
		repair_slider->next_repair = new_repair_ptr;
	}

	printf("// done.\n");

/*
	printf("Listing the repair link-list\n");
	repair_slider = (*repair_head);
	while(repair_slider) {
		printf("%ld, %ld, %d\n",
				repair_slider->x,
				repair_slider->y,
				repair_slider->type);
		repair_slider = repair_slider->next_repair;
	}
	printf("done.\n");
*/
	return 1;
}
