#include <stdio.h>
#include <dlfcn.h>
#include <stdlib.h>

#include "../common/loadall.h"
#include "loadmod.h"
#include "s_basic_tred.h"

int move_with_check(struct server_info_hold*, node_robot_ptr, int, long);
int after_effect_turn(struct node_robot_type*, struct node_tred_type*, int);

struct node_robot_type* get_robot_head(server_info)
struct server_info_hold *server_info;
{
	struct node_module_type *module_slider;
	struct node_robot_type* (*_get_robot_head)(void);

	module_slider = server_info->module_head;
	while(module_slider) {
		if(!strcmp(module_slider->name, "s_robot")) {
			_get_robot_head = dlsym(
					module_slider->handle, "get_robot_head");
			return _get_robot_head();
		}

		module_slider = module_slider->next_module;
	}

	return NULL;
}

void action_treds(server_info, tred_e_head, priority)
struct server_info_hold *server_info;
struct node_tred_type *tred_e_head;
unsigned int priority;
{
	struct node_robot_type *test_robot_head;
	struct node_robot_type *test_slider, *robot_slider;
	struct node_robot_type *new_robot_ptr;
	struct node_robot_type *kill_slider;
	int (*_move_with_check)(struct server_info_hold*, int, long);
	int (*_is_here)(long, long, int);
	long (*_num_of_instances)(void);
	struct node_tred_type* (*get_tred_head)(void);
	long ctr;
	long count;
	int num_of_styles;
	int style;
	struct node_tred_type *tred_slider, *tred_n_head;
	struct node_module_type *module_slider;
	int after_movement_turn;
	int result;
	int tred_ref_id;
	char tosend[7];
	int movement_type;
	int robot_ref_id;

//	printf("moving treds now\n");

	/* make a copy of the robot link list */
	test_robot_head = NULL;
	robot_slider = get_robot_head(server_info);
	while(robot_slider) {
		if(robot_slider->damage != 10) {
			new_robot_ptr = (node_robot_ptr) calloc (1, sizeof(node_robot_type));

			new_robot_ptr->id_number = robot_slider->id_number;
			new_robot_ptr->current_location_xy.x =
					robot_slider->current_location_xy.x;
			new_robot_ptr->current_location_xy.y =
					robot_slider->current_location_xy.y;

			/* add this new robot node to head of link list */
			new_robot_ptr->next_robot = test_robot_head;
			test_robot_head = new_robot_ptr;
		}
		robot_slider = robot_slider->next_robot;
	}
	/* copy completed */
	/* the copy is moved to see if the move was allowed, non-virtual */
	/* robots on occuping the same square etc... after that knowledge */
	/* is gained the actual robots are moved */

    /**
     * find reference id numbers for network communications
     */
    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_basic_tred_n")) {
			get_tred_head = dlsym(
					module_slider->handle, "get_tred_head");
			tred_n_head = get_tred_head();
            tred_ref_id = module_slider->id;
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[BASIC_TRED_E] this point should never be reached\n");
        return;
    }                                                                          

	/* find next moveable object */
	module_slider = server_info->module_head;
	while(module_slider) {
		num_of_styles = module_slider->info->num_of_styles;
		for(style = 0; style < num_of_styles; style++) {
			if(!strcmp(module_slider->info->list_of_styles[style], "move")) {
				/* next moveable object found */

				/* loop through the instances of this module */
				_num_of_instances = dlsym(
						module_slider->handle, "num_of_instances");

				count = _num_of_instances();

				/* is this moveable module type at this location? */
				for(ctr = 0; ctr < count; ctr ++) {
					/* loop through all the express treds */
					tred_slider = tred_e_head;
					while(tred_slider) {
						/* */
						robot_ref_id = module_slider->id;

						/* */
						_move_with_check = dlsym(
								module_slider->handle,
								"move_with_check");

						/* is this tred at the location of the object */
						_is_here = dlsym(module_slider->handle, "is_here");

						/* if so move it appropriately */
						if(_is_here(tred_slider->x, tred_slider->y, ctr)) {
printf("[BASIC_TRED_E] FOUND & TESTING @ (%ld,%ld): moving instance %ld\n",
		tred_slider->x, tred_slider->y, ctr);

							switch(tred_slider->type) {
								case 0: movement_type = NORTH;	break;
								case 1: movement_type = EAST;	break;
								case 2: movement_type = SOUTH;	break;
								case 3: movement_type = WEST;	break;
								case 4: movement_type = WEST;	break;
								case 5: movement_type = NORTH;	break;
								case 6: movement_type = EAST;	break;
								case 7: movement_type = SOUTH;	break;
								case 8: movement_type = EAST;	break;
								case 9: movement_type = SOUTH;	break;
								case 10: movement_type = WEST;	break;
								case 11: movement_type = NORTH;	break;

								case 12: movement_type = NORTH;	break;
								case 13: movement_type = EAST;	break;
								case 14: movement_type = SOUTH;	break;
								case 15: movement_type = WEST;	break;
								case 16: movement_type = NORTH;	break;
								case 17: movement_type = EAST;	break;
								case 18: movement_type = SOUTH;	break;
								case 19: movement_type = WEST;	break;
								case 20: movement_type = NORTH;	break;
								case 21: movement_type = EAST;	break;
								case 22: movement_type = SOUTH;	break;
								case 23: movement_type = WEST;	break;
							}

							/* add one so it represents one of the */
							/* movements in the movement.h file */
							result = move_with_check(
									server_info,
									test_robot_head,
									movement_type,
									ctr);

							break;
						}

						tred_slider = tred_slider->next_tred;
					}
					/* now move normal treds */
					if(tred_slider == NULL) /* don't move normal treds if robot moved */
					if(priority != 15000) {
						tred_slider = tred_n_head;
						while(tred_slider) {
							/* */
							robot_ref_id = module_slider->id;

							/* */
							_move_with_check = dlsym(
									module_slider->handle,
									"move_with_check");

							/* is this tred at the location of the object */
							_is_here = dlsym(module_slider->handle, "is_here");

							/* if so move it appropriately */
							if(_is_here(tred_slider->x, tred_slider->y, ctr)) {
printf("[BASIC_TRED_N] FOUND & TESTING @ (%ld,%ld): moving instance %ld\n",
		tred_slider->x, tred_slider->y, ctr);

								switch(tred_slider->type) {
									case 0: movement_type = NORTH;	break;
									case 1: movement_type = EAST;	break;
									case 2: movement_type = SOUTH;	break;
									case 3: movement_type = WEST;	break;
									case 4: movement_type = WEST;	break;
									case 5: movement_type = NORTH;	break;
									case 6: movement_type = EAST;	break;
									case 7: movement_type = SOUTH;	break;
									case 8: movement_type = EAST;	break;
									case 9: movement_type = SOUTH;	break;
									case 10: movement_type = WEST;	break;
									case 11: movement_type = NORTH;	break;

									case 12: movement_type = NORTH;	break;
									case 13: movement_type = EAST;	break;
									case 14: movement_type = SOUTH;	break;
									case 15: movement_type = WEST;	break;
									case 16: movement_type = NORTH;	break;
									case 17: movement_type = EAST;	break;
									case 18: movement_type = SOUTH;	break;
									case 19: movement_type = WEST;	break;
									case 20: movement_type = NORTH;	break;
									case 21: movement_type = EAST;	break;
									case 22: movement_type = SOUTH;	break;
									case 23: movement_type = WEST;	break;
								}

								/* add one so it represents one of the */
								/* movements in the movement.h file */
								result = move_with_check(
										server_info,
										test_robot_head,
										movement_type,
										ctr);

								break;
							}
	
							tred_slider = tred_slider->next_tred;
						}
					}
				}
			}
		}

		module_slider = module_slider->next_module;
	}

	/* Now check for trouble... if two robots are now on the same location */
	/* then the movement is not allowed */
	robot_slider = get_robot_head(server_info);
	while(robot_slider) {
		count = 0;
		if(robot_slider->is_virtual == FALSE) {
			test_slider = test_robot_head;
			while(test_slider) {
				if(test_slider->is_virtual == FALSE) {
					if(robot_slider->current_location_xy.x
							== test_slider->current_location_xy.x) {
						if(robot_slider->current_location_xy.y
								== test_slider->current_location_xy.y) {
							count++;
						}
					}
				}

				test_slider = test_slider->next_robot;
			}
		}
		if(count <= 1) {
			/* ok to move this robot */

			/* loop through all the treds */
			tred_slider = tred_e_head;
			while(tred_slider) {
				/* is this tred at the location of the object */
//				_is_here = dlsym(module_slider->handle, "is_here");

				/* if so move it appropriately */
				if(_is_here(tred_slider->x, tred_slider->y, robot_slider->id_number)) {
printf("[BASIC_TRED_E] FOUND & MOVING @ (%ld,%ld): moving instance %ld\n",
		tred_slider->x, tred_slider->y, robot_slider->id_number);
//					_move_with_check = dlsym(
//							module_slider->handle,
//							"move_with_check");

					switch(tred_slider->type) {
						case 0: movement_type = NORTH;	break;
						case 1: movement_type = EAST;	break;
						case 2: movement_type = SOUTH;	break;
						case 3: movement_type = WEST;	break;
						case 4: movement_type = WEST;	break;
						case 5: movement_type = NORTH;	break;
						case 6: movement_type = EAST;	break;
						case 7: movement_type = SOUTH;	break;
						case 8: movement_type = EAST;	break;
						case 9: movement_type = SOUTH;	break;
						case 10: movement_type = WEST;	break;
						case 11: movement_type = NORTH;	break;

						case 12: movement_type = NORTH;	break;
						case 13: movement_type = EAST;	break;
						case 14: movement_type = SOUTH;	break;
						case 15: movement_type = WEST;	break;
						case 16: movement_type = NORTH;	break;
						case 17: movement_type = EAST;	break;
						case 18: movement_type = SOUTH;	break;
						case 19: movement_type = WEST;	break;
						case 20: movement_type = NORTH;	break;
						case 21: movement_type = EAST;	break;
						case 22: movement_type = SOUTH;	break;
						case 23: movement_type = WEST;	break;
					}

					/* add one so it represents one of the */
					/* movements in the movement.h file */
					result = _move_with_check(
							server_info,
							movement_type,
							robot_slider->id_number);

					tosend[0] = S_ACTION;
					tosend[1] = tred_ref_id;
					tosend[2] = -1;
					tosend[3] = robot_ref_id;
					tosend[4] = robot_slider->id_number;
					tosend[5] = 0;
					tosend[6] = movement_type;
					if(result != -1) {
						/* if the movement failed */
						tosend[6] += 10;
					}
					network_say_to_all(server_info, tosend, 7);

					/* move robot if it is now on a turn tred */
					after_movement_turn =
							after_effect_turn(robot_slider, tred_e_head, tred_slider->type);

					/* check for normal tred turns */
					if(after_movement_turn == -1) { /* if no turn tred found yet */
						after_movement_turn =
								after_effect_turn(robot_slider, tred_n_head, tred_slider->type);
					}

					if(after_movement_turn != -1) {
						printf("AFTERTURN: YES!!!\n");

						result = _move_with_check(
								server_info,
								after_movement_turn,
								robot_slider->id_number);

						tosend[0] = S_ACTION;
						tosend[1] = tred_ref_id;
						tosend[2] = -1;
						tosend[3] = robot_ref_id;
						tosend[4] = robot_slider->id_number;
						tosend[5] = 0;
						tosend[6] = after_movement_turn;
						if(result != -1) {
							/* if the movement failed */
							tosend[6] += 10;
						}
						network_say_to_all(server_info, tosend, 7);
					}

					break;
				}

				tred_slider = tred_slider->next_tred;
			}
			if(tred_slider == NULL) {
				if(priority != 15000) {
					tred_slider = tred_n_head;
					while(tred_slider) {
						/* is this tred at the location of the object */
//						_is_here = dlsym(module_slider->handle, "is_here");

						/* if so move it appropriately */
						if(_is_here(tred_slider->x, tred_slider->y, robot_slider->id_number)) {
printf("[BASIC_TRED_N] FOUND & MOVING @ (%ld,%ld): moving instance %ld\n",
		tred_slider->x, tred_slider->y, robot_slider->id_number);
//							_move_with_check = dlsym(
//									module_slider->handle,
//									"move_with_check");

							switch(tred_slider->type) {
								case 0: movement_type = NORTH;	break;
								case 1: movement_type = EAST;	break;
								case 2: movement_type = SOUTH;	break;
								case 3: movement_type = WEST;	break;
								case 4: movement_type = WEST;	break;
								case 5: movement_type = NORTH;	break;
								case 6: movement_type = EAST;	break;
								case 7: movement_type = SOUTH;	break;
								case 8: movement_type = EAST;	break;
								case 9: movement_type = SOUTH;	break;
								case 10: movement_type = WEST;	break;
								case 11: movement_type = NORTH;	break;

								case 12: movement_type = NORTH;	break;
								case 13: movement_type = EAST;	break;
								case 14: movement_type = SOUTH;	break;
								case 15: movement_type = WEST;	break;
								case 16: movement_type = NORTH;	break;
								case 17: movement_type = EAST;	break;
								case 18: movement_type = SOUTH;	break;
								case 19: movement_type = WEST;	break;
								case 20: movement_type = NORTH;	break;
								case 21: movement_type = EAST;	break;
								case 22: movement_type = SOUTH;	break;
								case 23: movement_type = WEST;	break;
							}

							/* add one so it represents one of the */
							/* movements in the movement.h file */
							result = _move_with_check(
									server_info,
									movement_type,
									robot_slider->id_number);

							tosend[0] = S_ACTION;
							tosend[1] = tred_ref_id;
							tosend[2] = -1;
							tosend[3] = robot_ref_id;
							tosend[4] = robot_slider->id_number;
							tosend[5] = 0;
							tosend[6] = movement_type;
							if(result != -1) {
								/* if the movement failed */
								tosend[6] += 10;
							}
							network_say_to_all(server_info, tosend, 7);

							/* move robot if it is now on a turn tred */
							after_movement_turn =
									after_effect_turn(
											robot_slider,
											tred_e_head,
											tred_slider->type);

							/* check for normal tred turns */
							if(after_movement_turn == -1) { /* if no turn tred found yet */
								after_movement_turn =
										after_effect_turn(
												robot_slider,
												tred_n_head,
												tred_slider->type);
							}
		
							if(after_movement_turn != -1) {
								printf("AFTERTURN: YES!!!\n");
		
								result = _move_with_check(
										server_info,
										after_movement_turn,
										robot_slider->id_number);
		
								tosend[0] = S_ACTION;
								tosend[1] = tred_ref_id;
								tosend[2] = -1;
								tosend[3] = robot_ref_id;
								tosend[4] = robot_slider->id_number;
								tosend[5] = 0;
								tosend[6] = after_movement_turn;
								if(result != -1) {
									/* if the movement failed */
									tosend[6] += 10;
								}
								network_say_to_all(server_info, tosend, 7);
							}
		
							break;
						}

						tred_slider = tred_slider->next_tred;
					}
				}
			}
		}
		else {
			/* do not move this robot */
		}
		robot_slider = robot_slider->next_robot;
	}

	/* clear out the robot node list we created just for the previous test */
	robot_slider = test_robot_head;
	while(robot_slider) {
		kill_slider = robot_slider;
		robot_slider = robot_slider->next_robot;

		free(kill_slider);
	}
}

/**
 */
int move_with_check(server_info, robot_head, move_type, roboNum)
struct server_info_hold *server_info;
node_robot_ptr robot_head;
int move_type;
long roboNum;
{
	struct node_robot_type *robot_slider;
	int blocked;
	long old_x, old_y;
	long new_x, new_y;
	int old_facing, new_facing;

	printf("[BASIC_TRED_E] Moving (with check) type %d\n", move_type);

	/**
	 * find robot node to move
	 */
	robot_slider = robot_head;
	while(robot_slider) {
		if(robot_slider->id_number == roboNum) {
			break;
		}
		robot_slider = robot_slider->next_robot;
	}
	if(!robot_slider) {
		printf("[ROBOT] This point should never be reached.\n");
		return TRUE;
	}

	if(robot_slider->damage == 10) {
		return 999;
	}

	/**
	 * store values before movement
	 */
	old_x = robot_slider->current_location_xy.x;
	old_y = robot_slider->current_location_xy.y;
	old_facing = robot_slider->facing_direction;
	new_x = old_x;
	new_y = old_y;
	new_facing = old_facing;

	/**
	 * generate the potential move
	 */
	switch(move_type) {
		case U_TURN:
			new_facing = (new_facing + 1) % 4;
			new_facing = (new_facing + 1) % 4;
			break;
		case ROTATE_LEFT:
			new_facing = (new_facing + 1) % 4;
			new_facing = (new_facing + 1) % 4;
			new_facing = (new_facing + 1) % 4;
			break;
		case ROTATE_RIGHT:
			new_facing = (new_facing + 1) % 4;
			break;
		case BACK_UP:
			switch(old_facing) {
				case 0: ++new_y; break;
				case 1: --new_x; break;
				case 2: --new_y; break;
				case 3: ++new_x; break;
			}
			break;
		case FORWARD:
			switch(old_facing) {
				case 0: --new_y; break;
				case 1: ++new_x; break;
				case 2: ++new_y; break;
				case 3: --new_x; break;
			}
			break;
		case NORTH:
			--new_y;
			break;
		case EAST:
			++new_x;
			break;
		case SOUTH:
			++new_y;
			break;
		case WEST:
			--new_x;
			break;
	}

	/**
	 * see if the movement is allowed
	 */
//	check4stop(server_info, from_x, from_y, to_x, to_y);
	blocked = check4stop(server_info, old_x, old_y, new_x, new_y);

	/**
	 * move the robot
	 */
	if(blocked == -1) {
		robot_slider->current_location_xy.x = new_x;
		robot_slider->current_location_xy.y = new_y;
		robot_slider->facing_direction = new_facing;
	}

	/* this value is the module id or -1 if not blocked */
	return (blocked);
}

int after_effect_turn(robot_slider, tred_head, tred_type)
struct node_robot_type *robot_slider;
struct node_tred_type *tred_head;
int tred_type;
{
	node_tred_ptr check4turn;
	int after_movement_turn;

	/* if the robot is now on a turn tred because */
	/* of a tred it should be turned */
	after_movement_turn = -1;
	check4turn = tred_head;
	while(check4turn) {
		if(check4turn->x == robot_slider->current_location_xy.x) {
			if(check4turn->y == robot_slider->current_location_xy.y) {
				if(check4turn->type >= 4) {
					if(check4turn->type <= 7) {
						/* ROTATE_RIGHT */
						after_movement_turn = ROTATE_RIGHT;
					}
					else if(check4turn->type <= 11) {
						/* ROTATE_LEFT */
						after_movement_turn = ROTATE_LEFT;
					}
					else if(check4turn->type <= 15) {
						switch(check4turn->type) {
							case 12:
								switch(tred_type) {
									case 1:
									case 13:
									case 17:
									case 21:
										/* rotate_left */
										after_movement_turn = ROTATE_LEFT;
										break;
								}
								break;
							case 13:
								switch(tred_type) {
									case 2:
									case 14:
									case 18:
									case 22:
										/* rotate_left */
										after_movement_turn = ROTATE_LEFT;
										break;
								}
								break;
							case 14:
								switch(tred_type) {
									case 3:
									case 15:
									case 19:
									case 23:
										/* rotate_left */
										after_movement_turn = ROTATE_LEFT;
										break;
								}
								break;
							case 15:
								switch(tred_type) {
									case 0:
									case 12:
									case 16:
									case 20:
										/* rotate_left */
										after_movement_turn = ROTATE_LEFT;
										break;
								}
								break;
						}
					}
					else if(check4turn->type <= 19) {
						switch(check4turn->type) {
							case 16:
								switch(tred_type) {
									case 3:
									case 15:
									case 19:
									case 23:
										/* rotate_right */
										after_movement_turn = ROTATE_RIGHT;
										break;
								}
								break;
							case 17:
								switch(tred_type) {
									case 0:
									case 12:
									case 16:
									case 20:
										/* rotate_right */
										after_movement_turn = ROTATE_RIGHT;
										break;
								}
								break;
							case 18:
								switch(tred_type) {
									case 1:
									case 13:
									case 17:
									case 21:
										/* rotate_right */
										after_movement_turn = ROTATE_RIGHT;
										break;
								}
								break;
							case 19:
								switch(tred_type) {
									case 2:
									case 14:
									case 18:
									case 22:
										/* rotate_right */
										after_movement_turn = ROTATE_RIGHT;
										break;
								}
								break;
						}
					}
					else if(check4turn->type <= 23) {
						switch(check4turn->type) {
							case 20:
								switch(tred_type) {
									case 1:
									case 13:
									case 17:
									case 21:
										/* rotate_left */
										after_movement_turn = ROTATE_LEFT;
										break;
									case 3:
									case 15:
									case 19:
									case 23:
										/* rotate_right */
										after_movement_turn = ROTATE_RIGHT;
										break;
								}
								break;
							case 21:
								switch(tred_type) {
									case 0:
									case 12:
									case 16:
									case 20:
										/* rotate_right */
										after_movement_turn = ROTATE_RIGHT;
										break;
									case 2:
									case 14:
									case 18:
									case 22:
										/* rotate_left */
										after_movement_turn = ROTATE_LEFT;
										break;
								}
								break;
							case 22:
								switch(tred_type) {
									case 1:
									case 13:
									case 17:
									case 21:
										/* rotate_right */
										after_movement_turn = ROTATE_RIGHT;
										break;
									case 3:
									case 15:
									case 19:
									case 23:
										/* rotate_left */
										after_movement_turn = ROTATE_LEFT;
										break;
								}
								break;
							case 23:
								switch(tred_type) {
									case 0:
									case 12:
									case 16:
									case 20:
										/* rotate_left */
										after_movement_turn = ROTATE_LEFT;
										break;
									case 2:
									case 14:
									case 18:
									case 22:
										/* rotate_right */
										after_movement_turn = ROTATE_RIGHT;
										break;
								}
								break;
						}
					}
				}
				/* we found a match, no need to look for more
				 * turn treds
				 */
				break;
			}
		}
		check4turn = check4turn->next_tred;
	}

	return after_movement_turn;
}
