/**
 * Creates and adds new tred node to the link list of treds used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"
#include "s_basic_tred.h"

/**
 */
int add_tred_node(server_info, tred_head, user_node)
struct server_info_hold *server_info;
struct node_tred_type **tred_head;
struct node_user_type *user_node;
{
	node_tred_ptr tred_slider;
	node_tred_ptr new_tred_ptr;

	printf("// Adding new tred node\n");

	/* Allocate a new tred node for this new user */
	new_tred_ptr = (node_tred_ptr) calloc (1, sizeof(node_tred_type));

	/* Fill in the new information about the tred */
	new_tred_ptr->x = (long)(user_node->buffer[0] * 250 + user_node->buffer[1]);
	new_tred_ptr->y = (long)(user_node->buffer[2] * 250 + user_node->buffer[3]);
	new_tred_ptr->type = user_node->buffer[4];
	new_tred_ptr->is_express = FALSE;
	/* The next node is always NULL */
	new_tred_ptr->next_tred = NULL;

	/* Move to the end of the node list & attach */
	tred_slider = (*tred_head);
	if(tred_slider == NULL) {
		(*tred_head) = new_tred_ptr;
	}
	else if(tred_slider->next_tred == NULL) {
		tred_slider->next_tred = new_tred_ptr;
	}
	else {
		do {
			tred_slider = tred_slider->next_tred;
		} while(tred_slider->next_tred != NULL);
		tred_slider->next_tred = new_tred_ptr;
	}

//	printf("// done.\n");
/*
	printf("Listing the tred link-list\n");
	tred_slider = (*tred_head);
	while(tred_slider) {
		printf("%ld, %ld, %d\n",
				tred_slider->x,
				tred_slider->y,
				tred_slider->type);
		tred_slider = tred_slider->next_tred;
	}
	printf("done.\n");
*/
	return 1;
}
