/**
 * Creates and adds new wall node to the link list of walls used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"
#include "s_basic_wall.h"

/**
 */
int add_wall_node(server_info, wall_head, user_node)
struct server_info_hold *server_info;
struct node_wall_type **wall_head;
struct node_user_type *user_node;
{
	node_wall_ptr wall_slider;
	node_wall_ptr new_wall_ptr;

	printf("// Adding new wall node\n");

	/* Allocate a new wall node for this new user */
	new_wall_ptr = (node_wall_ptr) calloc (1, sizeof(node_wall_type));

	/* Fill in the new information about the wall */
	new_wall_ptr->x = (long)(user_node->buffer[0] * 250 + user_node->buffer[1]);
	new_wall_ptr->y = (long)(user_node->buffer[2] * 250 + user_node->buffer[3]);
	new_wall_ptr->type = user_node->buffer[4];
	/* The next node is always NULL */
	new_wall_ptr->next_wall = NULL;

	/* Move to the end of the node list & attach */
	wall_slider = (*wall_head);
	if(wall_slider == NULL) {
		(*wall_head) = new_wall_ptr;
	}
	else if(wall_slider->next_wall == NULL) {
		wall_slider->next_wall = new_wall_ptr;
	}
	else {
		do {
			wall_slider = wall_slider->next_wall;
		} while(wall_slider->next_wall != NULL);
		wall_slider->next_wall = new_wall_ptr;
	}

	printf("// done.\n");
/*
	printf("Listing the wall link-list\n");
	wall_slider = (*wall_head);
	while(wall_slider) {
		printf("%ld, %ld, %d\n",
				wall_slider->x,
				wall_slider->y,
				wall_slider->type);
		wall_slider = wall_slider->next_wall;
	}
	printf("done.\n");
*/
	return 1;
}
