/**
 * Creates and adds new p_card node to the link list of p_cards used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"
#include "s_p_card.h"

/**
 */
int add_p_card_node(server_info, p_card_head, user_node)
struct server_info_hold *server_info;
struct node_p_card_type **p_card_head;
struct node_user_type *user_node;
{
	node_p_card_ptr p_card_slider;
	node_p_card_ptr new_p_card_ptr;

//	printf("// Adding new p_card node\n");

	/* Allocate a new p_card node for this new user */
	new_p_card_ptr = (node_p_card_ptr) calloc (1, sizeof(node_p_card_type));

	/* Fill in the new information about the p_card */
	new_p_card_ptr->roboNum = user_node->id_number;
	new_p_card_ptr->number_of_p_cards_available = 0;
	new_p_card_ptr->number_of_p_cards_selected = 0;
//	new_p_card_ptr->p_cards[0] =;
//	new_p_card_ptr->selected[0] =;
	new_p_card_ptr->locked_registers[0] = 0;
	new_p_card_ptr->locked_registers[1] = 0;
	new_p_card_ptr->locked_registers[2] = 0;
	new_p_card_ptr->locked_registers[3] = 0;
	new_p_card_ptr->locked_registers[4] = 0;
	new_p_card_ptr->is_ready = TRUE;

	/* The next node is always NULL */
	new_p_card_ptr->next_p_card = NULL;

	/* Move to the end of the node list & attach */
	p_card_slider = (*p_card_head);
	if(p_card_slider == NULL) {
		(*p_card_head) = new_p_card_ptr;
	}
	else if(p_card_slider->next_p_card == NULL) {
		p_card_slider->next_p_card = new_p_card_ptr;
	}
	else {
		do {
			p_card_slider = p_card_slider->next_p_card;
		} while(p_card_slider->next_p_card != NULL);
		p_card_slider->next_p_card = new_p_card_ptr;
	}

//	printf("// done.\n");
/*
	printf("Listing the p_card link-list\n");
	p_card_slider = (*p_card_head);
	while(p_card_slider) {
		printf("%d, %d\n",
			new_p_card_ptr->roboNum,
			new_p_card_ptr->is_ready);
		p_card_slider = p_card_slider->next_p_card;
	}
	printf("done.\n");
*/
	return 1;
}
