/**
 *
 *
 * Module Dependencies: robot
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include "../common/loadall.h"
#include "loadmod.h"
#include "s_p_card.h"
#include "is_shutdown.h"

unsigned int case_deal_program_cards(server_info, p_card_head, the_deck)
struct server_info_hold *server_info;
struct node_p_card_type **p_card_head;
unsigned int *the_deck;
{
	struct node_p_card_type* p_card_slider;
	struct node_user_type *user_slider;
	unsigned char tosend[512];
	unsigned int ptr, number_of_players;

	number_of_players = 0;

	ptr = 0;

	/* Add each user one by one */
	user_slider = server_info->user_head;
	while(user_slider) {
		if(!is_shutdown(server_info, user_slider->id_number)) {
			p_card_slider = (*p_card_head);
			while(p_card_slider) {
				if(p_card_slider->roboNum == user_slider->id_number) {
					break;
				}
				p_card_slider = p_card_slider->next_p_card;
			}

			if(p_card_slider) {
				tosend[0] = S_PROGRAM_CARD_LIST;
				tosend[1] = 9;
				tosend[2] = the_deck[ptr++];
				tosend[3] = the_deck[ptr++];
				tosend[4] = the_deck[ptr++];
				tosend[5] = the_deck[ptr++];
				tosend[6] = the_deck[ptr++];
				tosend[7] = the_deck[ptr++];
				tosend[8] = the_deck[ptr++];
				tosend[9] = the_deck[ptr++];
				tosend[10] = the_deck[ptr++];

				/* This player needs to send in their cards. */
				p_card_slider->is_ready = FALSE;

				/* store the cards in the program card node */
				p_card_slider->number_of_p_cards_available = 9;
				p_card_slider->p_cards[0] = tosend[2];
				p_card_slider->p_cards[1] = tosend[3];
				p_card_slider->p_cards[2] = tosend[4];
				p_card_slider->p_cards[3] = tosend[5];
				p_card_slider->p_cards[4] = tosend[6];
				p_card_slider->p_cards[5] = tosend[7];
				p_card_slider->p_cards[6] = tosend[8];
				p_card_slider->p_cards[7] = tosend[9];
				p_card_slider->p_cards[8] = tosend[10];
				p_card_slider->p_cards[9] = tosend[11];
	
				if(ptr > 76) {
					/* Out of cards, can't deal anymore */
					printf("[P_CARD] Out of cards, can't deal anymore!\n");
					break;
				}

				/* Send program cards to user */
				network_say_to_user(
						server_info, tosend, 11, user_slider->id_number);
			}
		}

		user_slider = user_slider->next_user;
	}

	return number_of_players;
}
