/**
 * When functions in other modules are called, place them in here. This should
 * be the only file in a module with #include <dlfcn.h>.
 *
 * Module Dependencies: robot
 * Author: Travis W. Loyd
 */

#include <dlfcn.h>
#include "../common/loadall.h"

int is_shutdown(server_info, id_number)
struct server_info_hold *server_info;
unsigned int id_number;
{
	int (*_is_shutdown)(long);
	struct node_module_type* module_slider;

	/* Find the robot module we need */
	module_slider = server_info->module_head;
	while(module_slider) {
		if(!strcmp(module_slider->name, "s_robot")) {
			break;
		}

		module_slider = module_slider->next_module;
	}

	/* Call the function to add the new robot node */
	_is_shutdown = dlsym(module_slider->handle,
			"is_shutdown");

	return _is_shutdown(id_number);
}
