#include <stdio.h>
#include "../common/loadall.h"
#include "loadmod.h"
#include "dealpcard.h"

int case_program_card_list(server_info, p_card_head, user_node)
struct server_info_hold *server_info;
struct node_p_card_type **p_card_head;
struct node_user_type *user_node;
{
	struct node_p_card_type *p_card_slider;
	int ctr, program_cards_were_valid;
	int loop_1, loop_2, test;
	char tosend[512];

	p_card_slider = (*p_card_head);
	while(p_card_slider) {
		if(p_card_slider->roboNum == user_node->id_number) {
			break;
		}
		p_card_slider = p_card_slider->next_p_card;
	}

	if(!p_card_slider) {
		/* This user isn't even a player, they shouldn't be */
		/* sending in a program card selection command. */
		printf("[P_CARD] user who is not a player sent in program cards.\n");
		return FALSE;
	}

	/* store program cards in the program card node */
	p_card_slider->number_of_p_cards_selected = user_node->buffer[1];
	for(ctr = 0; ctr < user_node->buffer[1]; ctr ++) {
		if(p_card_slider->number_of_p_cards_selected <= 5) {
			p_card_slider->selected[ctr] = user_node->buffer[2 + ctr];
		}
	}

	remove_chars_from_user_buffer(user_node, user_node->buffer[1] + 2);

	/**
	 * Are these program cards valid?
	 */
	program_cards_were_valid = TRUE;

	/* each card is one of the possible program cards */
	for(test = loop_1 = 0; loop_1 < 5; loop_1++) {
		if(!p_card_slider->locked_registers[loop_1]) {
			for(loop_2 = 0; loop_2 < p_card_slider->number_of_p_cards_available; loop_2++) {
				if(p_card_slider->selected[loop_1] == p_card_slider->p_cards[loop_2]) {
					test++;
				}
			}
		}
	}
	if(test != p_card_slider->number_of_p_cards_selected) {
		program_cards_were_valid = FALSE;
	}

	/* no cards are repeated */
	for(loop_1 = 0; loop_1 < 5; loop_1++) {
		if(!p_card_slider->locked_registers[loop_1]) {
			for(test = loop_2 = 0; loop_2 < 5; loop_2++) {
				if(p_card_slider->selected[loop_1] == p_card_slider->selected[loop_2]) {
					test++;
				}
			}
			if(test != 1) {
				program_cards_were_valid = FALSE;
				break;
			}
		}
	}

	/* Send message to client saying his program card selection was valid or */
	/* that it wasn't. */
	tosend[0] = S_REPLY_PROGRAM_CARD;
	tosend[1] = p_card_slider->roboNum;
	tosend[2] = program_cards_were_valid;

	if(program_cards_were_valid) {
		/* Send the message to everyone */
		network_say_to_all(server_info, tosend, 3);
	}
	else {
		/* Send the message to the user */
		network_say_to_user(server_info, tosend, 3, user_node->id_number);
	}

	p_card_slider->is_ready = program_cards_were_valid;

	return program_cards_were_valid;
}
