/**
 * When functions in other modules are called, place them in here. This should
 * be the only file in a module with #include <dlfcn.h>.
 *
 * Module Dependencies: robot
 * Author: Travis W. Loyd
 */

#include <dlfcn.h>
#include "../common/loadall.h"

int store_selected_program_cards(server_info, selected, id_number)
struct server_info_hold *server_info;
unsigned char *selected;
unsigned int id_number;
{
	int (*put_users_selected_program_cards)(
			struct server_info_hold*, char*, unsigned int);
	struct node_module_type* module_slider;

	/* Find the robot module we need */
	module_slider = server_info->module_head;
	while(module_slider) {
		if(!strcmp(module_slider->name, "s_robot")) {
			break;
		}

		module_slider = module_slider->next_module;
	}

	/* Call the function to add the new robot node */
	put_users_selected_program_cards = dlsym(module_slider->handle,
			"put_selected_program_cards_into_robot");

	return put_users_selected_program_cards(server_info, selected, id_number);
}

void store_the_program_cards(server_info, delt_cards, id_number)
struct server_info_hold *server_info;
unsigned char *delt_cards;
unsigned int id_number;
{
	void (*store_program_cards)(
		struct server_info_hold*
		, unsigned char*
		, unsigned int);
	struct node_module_type* module_slider;

	/* Find the robot module we need */
	module_slider = server_info->module_head;
	while(module_slider) {
		if(!strcmp(module_slider->name, "s_robot")) {
			break;
		}

		module_slider = module_slider->next_module;
	}

	/* Call the function to add the new robot node */
	store_program_cards = dlsym(module_slider->handle,
			"store_program_cards_in_robot");

	store_program_cards(server_info, delt_cards, id_number);
}

int is_user_a_player(server_info, id_number)
struct server_info_hold *server_info;
unsigned int id_number;
{
	struct node_robot_type* (*is_the_user_a_player)(
		struct server_info_hold*
		, unsigned int);
	struct node_module_type* module_slider;

	/* Find the robot module we need */
	module_slider = server_info->module_head;
	while(module_slider) {
		if(!strcmp(module_slider->name, "s_robot")) {
			break;
		}

		module_slider = module_slider->next_module;
	}

	/* Call the function to add the new robot node */
	is_the_user_a_player = dlsym(module_slider->handle,
			"is_player");

	return (int)is_the_user_a_player(server_info, id_number);
}
