/**
 * Creates and adds new robot node to the link list of robots used during game
 * play.
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include <stdlib.h>
#include "../common/loadall.h"

int add_new_robot_node_to_link_list(server_info, robot_head, user_node)
struct server_info_hold *server_info;
struct node_robot_type **robot_head;
struct node_user_type *user_node;
{
	node_robot_ptr robot_slider;
	node_robot_ptr new_robot_ptr;

//	printf("// Adding new robot node\n");

	/* Allocate a new robot node for this new user */
	new_robot_ptr = (node_robot_ptr) calloc (1, sizeof(node_robot_type));

	/* Fill in the new information about the robot */
	new_robot_ptr->id_number = user_node->id_number;
	/* By default the robot will not participate when the game starts. */
	new_robot_ptr->will_play_when_game_starts = TRUE;
	/* Set archive location to a default of 0x0 */
	new_robot_ptr->archive_location_xy.x = 0;
	new_robot_ptr->archive_location_xy.y = 0;
	/* Set robot's current location at that same spot */
	new_robot_ptr->current_location_xy.x = 0;
	new_robot_ptr->current_location_xy.y = 0;
	/* Robots start with no damage */
	new_robot_ptr->damage = 0;
	new_robot_ptr->is_virtual = FALSE;
	new_robot_ptr->is_shutdown = FALSE;
	new_robot_ptr->shut_me_down = FALSE;
	new_robot_ptr->lives = 2;
	new_robot_ptr->next_checkpoint = 0;
	/* The next node is always NULL */
	new_robot_ptr->next_robot = NULL;

	/* Move to the end of the node list & attach */
	robot_slider = (*robot_head);
	if(robot_slider == NULL) {
		(*robot_head) = new_robot_ptr;
	}
	else if(robot_slider->next_robot == NULL) {
		robot_slider->next_robot = new_robot_ptr;
	}
	else {
		do {
			robot_slider = robot_slider->next_robot;
		} while(robot_slider->next_robot != NULL);
		robot_slider->next_robot = new_robot_ptr;
	}

//	printf("// done.\n");

	return 1;
}
