/**
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include "../common/loadall.h"

int set_spawning_direction_in_robot(server_info, robot_head, user_node)
struct server_info_hold *server_info;
struct node_robot_type *robot_head;
struct node_user_type *user_node;
{
	struct node_robot_type* robot_slider;
	char tosend[512];

	/* Is the new spawn direction even valid? We only work if it is. */
	if(user_node->buffer[1] <= 3) {
		/* Find robot associated with id_number */
		robot_slider = robot_head;
		while(robot_slider) {
			if(robot_slider->id_number == user_node->id_number) {
				/* Change their spawning direction */
				robot_slider->facing_direction = user_node->buffer[1];

				break;
			}

			robot_slider = robot_slider->next_robot;
		}
	}
	else {
		/* Protocol invalid, new facing direction not valid */
		remove_chars_from_user_buffer(user_node, 2);

		tosend[0] = S_REPLY_SPAWNING_DIRECTION;
		tosend[1] = user_node->id_number;
		tosend[2] = FALSE;
		network_say_to_user(server_info, tosend, 3, user_node->id_number);

		return 0;
	}

	remove_chars_from_user_buffer(user_node, 2);

	tosend[0] = S_REPLY_SPAWNING_DIRECTION;
	tosend[1] = user_node->id_number;
	tosend[2] = TRUE;
	network_say_to_all(server_info, tosend, 3);

	return 1;
}
