/**
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include "../common/loadall.h"
#include "spawn.h"
#include "getmodid.h"
#include "s_robot.h"

void handle_shutdown(server_info, robot_head)
struct server_info_hold *server_info;
struct node_robot_type *robot_head;
{
	struct node_module_type* module_slider;
	struct node_robot_type* robot_slider;
	int robot_ref_id;
	char tosend[7];

    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_robot")) {
            robot_ref_id = module_slider->id;
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[ROBOT] this point should never be reached\n");
        return;
    }                                                                                        

	/* restart all shutdown robots */
	robot_slider = robot_head;
	while(robot_slider) {
		if(robot_slider->is_shutdown) {
			robot_slider->is_shutdown = FALSE;
			robot_slider->damage = 0;

			tosend[0] = S_ACTION;
			tosend[1] = robot_ref_id;
			tosend[2] = -1;
			tosend[3] = robot_ref_id;
			tosend[4] = robot_slider->id_number;
			tosend[5] = 5;
			network_say_to_all(server_info, tosend, 6);
		}

		robot_slider = robot_slider->next_robot;
	}

	/* shutdown all robots which are not dead and have requested it */
	/* if they are now dead remove the request to shutdown */
	robot_slider = robot_head;
	while(robot_slider) {
		if(robot_slider->shut_me_down) {
			robot_slider->shut_me_down = FALSE;

			if(robot_slider->damage != 10) {
				robot_slider->is_shutdown = TRUE;

				tosend[0] = S_ACTION;
				tosend[1] = robot_ref_id;
				tosend[2] = -1;
				tosend[3] = robot_ref_id;
				tosend[4] = robot_slider->id_number;
				tosend[5] = 4;
				network_say_to_all(server_info, tosend, 6);
			}
		}

		robot_slider = robot_slider->next_robot;
	}
}
