/**
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include "../common/loadall.h"
#include "spawn.h"
#include "getmodid.h"
#include "s_robot.h"

void spawn_dead_robots(server_info, robot_head)
struct server_info_hold *server_info;
struct node_robot_type *robot_head;
{
	struct node_module_type* module_slider;
	struct node_robot_type* robot_slider;
	int robot_ref_id;
	char tosend[7];
	int game_over;

	game_over = 1;
	robot_slider = robot_head;
	while(robot_slider) {
		if(robot_slider->lives != 0) {
			game_over = 0;
			break;
		}
        robot_slider = robot_slider->next_robot;
	}
	if(game_over) {
		server_info->set_game_in_progress = 2;
	}

    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_robot")) {
            robot_ref_id = module_slider->id;
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[ROBOT] this point should never be reached\n");
        return;
    }                                                                                        

	/* spawn all dead robots who are allowed to spawn */
	robot_slider = robot_head;
	while(robot_slider) {
		if(robot_slider->damage == 10) {
			if(robot_slider->lives > 0) {
				robot_slider->damage = 0;
				robot_slider->lives--;
				robot_slider->is_virtual = -1;
				robot_slider->current_location_xy.x =
						robot_slider->archive_location_xy.x;
				robot_slider->current_location_xy.y =
						robot_slider->archive_location_xy.y;

				/* spawn later after everyone sends in their direction */
				robot_slider->spawn_me = TRUE;

				/* tell the player to send their facing direction */
				robot_slider->facing_direction = -1;
				tosend[0] = S_ACTION;
				tosend[1] = robot_ref_id;
				tosend[2] = -1;
				tosend[3] = robot_ref_id;
				tosend[4] = robot_slider->id_number;
				tosend[5] = 3;
				network_say_to_all(server_info, tosend, 6);
			}
		}

		robot_slider = robot_slider->next_robot;
	}
}
