/**
 *
 * Author: Travis W. Loyd
 */

#include <stdio.h>
#include "../common/loadall.h"
#include "spawn.h"
#include "getmodid.h"
#include "s_robot.h"

void toggle_virtual(server_info, robot_head)
struct server_info_hold *server_info;
struct node_robot_type *robot_head;
{
	struct node_module_type *module_slider;
	struct node_robot_type *robot_slider, *check_slider;
	int robot_ref_id, count;
	char tosend[7];

    module_slider = server_info->module_head;
    while(module_slider) {
        if(!strcmp(module_slider->name, "s_robot")) {
            robot_ref_id = module_slider->id;
            break;
        }
 
        module_slider = module_slider->next_module;
    }
    if(!module_slider) {
        printf("[ROBOT] this point should never be reached\n");
        return;
    }                                                                                        

	/* find all robots which are virtual which should no longer */
	/* be and make them non-virtual */
	robot_slider = robot_head;
	while(robot_slider) {
		if(robot_slider->damage > 10) {
			if(robot_slider->is_virtual) {
				/* test, should this robot still be virtual? */
				count = 0;
				check_slider = robot_head;
				while(check_slider) {
					if(check_slider->damage > 10) {
						if(robot_slider->current_location_xy.x ==
								check_slider->current_location_xy.x) {
							if(robot_slider->current_location_xy.y ==
									check_slider->current_location_xy.y) {
								count++;
							}
						}
					}

					check_slider = check_slider->next_robot;
				}
				if(count == 1) {
					robot_slider->is_virtual = FALSE;

					tosend[0] = S_ACTION;
					tosend[1] = robot_ref_id;
					tosend[2] = -1;
					tosend[3] = robot_ref_id;
					tosend[4] = robot_slider->id_number;
					tosend[5] = 6;
					network_say_to_all(server_info, tosend, 6);
				}
			}
		}

		robot_slider = robot_slider->next_robot;
	}
}
